'****************************************************************
'*  Name    : STM00.bas                                         *
'*  Project : Testing the State Machine Template                *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) February 2017 [A. Freixanet 2017]   *
'*          : All Rights Reserved                               *
'*  Date    : 03/04/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   : Using the AMICUS18 Development Board              *
'*          : CPU : PIC18F25K20 with Xtal 16Mhz, & 4xPLL        *
'* Terminal Amicus      : Used for testing                      *
'* Powered by PROTON DEVELOPMENT SUITE COMPILER V3.5.9.3        *
'* Read individual Buttons                                      *
'* This code is prepared to download by the AGV BootloaderV4.1  *
'****************************************************************
'
'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'*******************************************************************************
' Testing the CODE by Proteus
'    $define _ProteusDebug_
'===============================================================================
' Choose the Bootloader you are using for the Amicus18 Board (real hardware).
' CHOOSE ONLY ONE.
$ifndef _ProteusDebug_

'    $define _AmicusBootloader_
    $define _LSM_AGV_BootloaderV41_

$endif
'===============================================================================

    Device = 18F25K20

    $ifdef _ProteusDebug_
    ' Settings CPU Proteus at 4Mhz (with settings fuses)
    Declare Xtal = 16
    $else
    ' Settings CPU Amicus18 Board at 16Mhz (with settings fuses)
    Declare Xtal = 64
    $endif
'*******************************************************************************
'* Name    : Compiler Declare                                                  *
'* Purpose : Configuration of the compiler                                     *
'* Notes   :                                                                   *
'******************************************************************************* 
    $if _defined(_LSM_AGV_BootloaderV41_) And _defined(_AmicusBootloader_)
        $error "ONLY CHOOSE ONE BOOTLOADER"
    $endif

    ' More security using the Bootloader in the Low Side of ROM memory (only for real piece).
    $ifdef _LSM_AGV_BootloaderV41_
        Declare PROTON_START_ADDRESS = 2048
    $endif
    '---------------------------------------------------------------------------
    Declare Eeprom_Address = $F00000
    Declare Optimiser_Level = 2
    Declare Dead_Code_Remove = On
    Declare Create_Coff = On
    Declare Watchdog = On
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
    Declare Bootloader = Off
'    Declare Show_System_Variables = On
    Declare MemWrite_Int_Control = 1
    $if 65537 < _code
    Declare Access_Upper_64K = On
    $endif
'-------------------------------------------------------------------------------
'    $ifdef _ProteusDebug_
'    $define _PinsTest_
'    $endif
'*******************************************************************************
'* Name    : Config Fuses                                                      *
'* Purpose :                                                                   *
'* Notes   : 1 version for Proteus & another version for AGV LSM Bootloader    *
'******************************************************************************* 
$ifdef _ProteusDebug_
'-------------------------------------------------------------------------------
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	 ;Oscillator Switchover mode disabled
    PWRT = On	  ;PWRT enabled
    BOREN = On	 ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	  ;VBOR set to 2.2 V nominal
    WDTEN = OFF	    ;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	    ;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	     ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	  ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = OFF	;Boot block (000000-0007FFh) not code-protected
    CPD = OFF	;Data EEPROM not code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
'-------------------------------------------------------------------------------
$else
'-------------------------------------------------------------------------------
$ifdef _AmicusBootloader_
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	 ;Oscillator Switchover mode disabled
    PWRT = On	  ;PWRT enabled
    BOREN = On	 ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	  ;VBOR set to 2.2 V nominal
    WDTEN = OFF	    ;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	    ;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	     ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	  ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = OFF	;Boot block (000000-0007FFh) not code-protected
    CPD = OFF	;Data EEPROM not code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
$else
' Full Boot Block protected for the Low Side ROM Bootloader V4.1.
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	;Fail-Safe Clock Monitor disabled
    IESO = OFF	;Oscillator Switchover mode disabled
    PWRT = On	;PWRT enabled
    BOREN = On	;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	;VBOR set to 2.2 V nominal
    WDTEN = OFF	;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	;Stack full/underflow will cause Reset
    LVP = OFF	;Single-Supply ICSP disabled
    XINST = OFF	;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = On	;Boot block (000000-0007FFh) code-protected
    CPD = On	;Data EEPROM code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = On	;Boot Block (000000-0007FFh) write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = On	;Boot Block (000000-0007FFh) protected from table reads executed in other blocks
Config_End
$endif
'-------------------------------------------------------------------------------
$endif
'*******************************************************************************
'* Name    : LCD                                                               *
'* Purpose : Declare the LCD pins                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
' Configuration of the AMI18 LCD Shield for the AMicus18 Board.
'    Declare LCD_DTPin = PORTB.4         ' LCD's Data lines (D4 to D7)
'    Declare LCD_ENPin = PORTB.3         ' LCD's EN line
'    Declare LCD_RSPin = PORTB.2         ' LCD's RS line
'    Declare LCD_Interface = 4           ' 4-bit interface to LCD
'    Declare LCD_Lines = 2               ' LCD contains 2 lines
'    Declare LCD_DataUs = 50             ' Time to wait after print a data To LCD
'    Declare LCD_CommandUs = 2000        ' Time to wait after print a command to LCD
'    Declare LCD_Type = Alphanumeric     ' LCD type is alphanumeric
'    Symbol __LCD_CharsLenght = 16       ' For the AMI18 LCD Shield
'*******************************************************************************
'* Name    : Variables & Constants                                             *
'* Purpose : Declare the Variables or Constants                                *
'* Notes   : The local variables are declared for this State Machine file only *
'* Rules   : If the Variable is used once then get Local Variable.             *
'*         : If the Variable is used several times in a large loop in STM1     *
'*         : with STM2 or in others modules then get a Global Variable.        *
'******************************************************************************* 
' Definition of local Bytes for Main code only
$ifndef _SMLVBS_Block1_
    $define _SMLVBS_Block1_
    Dim SMLVSByte1 As Byte System     ' Local Variable System Byte1
    Dim SMLVSByte2 As Byte System     ' Local Variable System Byte2
    Dim SMLVSByte3 As Byte System     ' Local Variable System Byte3
    Dim SMLVSByte4 As Byte System     ' Local Variable System Byte4
$endif
' If you need more local Byte Variables, uncomment this block.
'$ifndef _SMLVBS_Block2_
'    $define _SMLVBS_Block2_
'    Dim SMLVSByte5 As Byte System     ' Local Variable System Byte1
'    Dim SMLVSByte6 As Byte System     ' Local Variable System Byte2
'    Dim SMLVSByte7 As Byte System     ' Local Variable System Byte3
'    Dim SMLVSByte8 As Byte System     ' Local Variable System Byte4
'$endif

' Definition of local Words For Main Code only
$ifndef _SMLVWS_Block1_
    $define _SMLVWS_Block1_
    Dim SMLVSWord1 As Word System     ' Local Variable System Word1
    Dim SMLVSWord2 As Word System     ' Local Variable System Word2
$endif
' If you need more local Word Variables, uncomment this block.
'$ifndef _SMLVWS_Block2_
'    $define _SMLVWS_Block2_
'    Dim SMLVSWord3 As Word System     ' Local Variable System Word1
'    Dim SMLVSWord4 As Word System     ' Local Variable System Word2
'$endif

' Definition of local DWords For Main Code only
'$ifndef _SMLVDWS_Block1_
'    $define _SMLVDWS_Block1_
'    Dim SMLVSDWord1 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord2 As DWord System     ' Local Variable System Word2
'$endif
' If you need more local Dword Variables, uncomment this block.
'$ifndef _SMLVDWS_Block2_
'    $define _SMLVDWS_Block2_
'    Dim SMLVSDWord3 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord4 As DWord System     ' Local Variable System Word2
'$endif

' Definition of local bits
'$ifndef _LVSBitS_Block1_
'    $define _LVSBitS_Block1_
'    Dim LVSBitsA As Byte System     ' Local Variable System byte
'$endif
'-------------------------------------------------------------------------------

' Global Bits for the USER
    Dim SM_UserFlags As Byte System
    Dim F_UserFunction1 As SM_UserFlags.0 
    Dim F_UserFunction2 As SM_UserFlags.1
    Dim F_UserFunction3 As SM_UserFlags.2
    Dim F_UserFunction4 As SM_UserFlags.3
    Dim F_UserFunction5 As SM_UserFlags.4
    Dim F_UserFunction6 As SM_UserFlags.5        
    Dim F_UserFunction7 As SM_UserFlags.6
    Dim F_UserFunction8 As SM_UserFlags.7

'-------------------------------------------------------------------------------
' Definition of the LEDS for the output virtual PORT for the AMI18 shield for Amicus18.
    Symbol LED0 = LATA.0
    Symbol LED1 = LATA.1
    Symbol LED2 = LATA.2
    Symbol LED3 = LATA.3
    Symbol LED4 = LATC.0
    Symbol LED5 = LATC.1
    Symbol LED6 = LATC.2
    Symbol LED7 = LATC.3
    Symbol LED8 = LATC.4
    Symbol LED9 = LATC.5  
'-------------------------------------------------------------------------------
    $ifdef _PinsTest_
    Symbol Test1 = LATC.5
    $endif
'*******************************************************************************
'* Name    : Language                                                          *
'* Purpose : Define one language for this project                              *
'* Notes   : One language must be enabled                                      *
'*******************************************************************************            
    $define _English_
'    $define _Spanish_
'    $define _French_ 
'*******************************************************************************
'* Name    : the ARRAYs in BANK0 and upward                                    *
'* Purpose : Define manually a Dummy Array                                     *
'* Notes   : Using a Dummy Byte as reference                                   *
'******************************************************************************* 
'    Dim MyDummyByte As Byte     ' This byte is to calculate the position of the Dummy Array

'    ' After last compiling, verify the address (in asm file) of the variable "MyDummyByte" 
'    ' and update the AddressofMyDummyByte value.
'    $define AddressofMyDummyByte 55

'    $ifdef _bankAend
'        $if AddressofMyDummyByte < _bankAend
'            $define DummyArray_Lenght _bankAend - AddressofMyDummyByte + 1
'            Dim DummyArray[DummyArray_Lenght] As Byte  
'        $endif
'    $else
'        $error "The _bankAend parameter is absent from the .def file of the PDS!"
'    $endif
'===============================================================================
'===============================================================================
' Bits definition of the PIC18F25K20.
'
    Include "D:\MyIncFiles\SYS_18FXXK20.inc"
'*******************************************************************************
'* Name    : State machine numbers                                             *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM_Init 0           ' STATE00
    $define SM_ButtonsOff 7     ' STATE07
    $define SM_ReadButtons 8    ' STATE08
    $define SM_LED0 9           ' STATE09
    $define SM_LED1 10          ' STATE10
    $define SM_LED2 11          ' STATE11
    $define SM_LED3 12          ' STATE12
    $define SM_LED4 13          ' STATE13
    $define SM_LED5 14          ' STATE14
    $define SM_LED6 15          ' STATE15
    $define SM_LED7 16          ' STATE16

'*******************************************************************************
'* Name    : State machine2 numbers                                            *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM2_Init 0         ' STATE100
    $define SM2_Message1 1     ' STATE101
    $define SM2_Message2 2     ' STATE102

'*******************************************************************************
'* Name    : USER FUNCTION 1 (only Meta Macro, no Subroutine)                  *
'* Purpose : Toggle the LED8                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'*******************************************************************************  
    $define StartFunction1() F_UserFunction1 = 1

    $define StopFunction1() F_UserFunction1 = 0 : LED8 = 0   

'*******************************************************************************
'* Name    : USER FUNCTION 2 (only Meta Macro, no Subroutine)                  *
'* Purpose : Set the LED9 for 250 mS                                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'******************************************************************************* 
    $define StartBeep() '
    F_UserFunction2 = 1 '
    LED9 = 1            '
    StartUserDelay2(250)

'*******************************************************************************
'* Name    : Enable the Library Commands included the STMachine00.Inc file     *
'* Notes   : Uncomment the line to enable a Library Command                    *
'*******************************************************************************
' Uncomment the followed line to insert the Keypad option.
'    $define _Disable_Pullups_
'    $define _4x4KEYPAD_
'    $define _4x3KEYPAD_
'    $define _4x2KEYPAD_
'-------------------------------------------------------------------------------
' Others States Machine libraries.
    $define _HRSE2PStrg_
'    $define _Manchester_
'    $define _MidPoint_
'    $define _MedianFilter_
'    $define _BubbleSort_
'    $define _GetParity_
'    $define _RotateBits_
'    $define _BinaryTo3BCD_
'    $define _BCD2ToBinary_
'    $define _WordTo5BCD_
'    $define _DwordArray_
'    $define _CountUntil_
'    $define _ArrayROL_
'    $define _ArrayROR_
'    $define _ArrayROLR_
'    $define _ArrayRORR_
'    $define _ArrayBit_
'    $define _CRC16_

'*******************************************************************************
'* Name    : HSerial                                                           *
'* Purpose : Declare the HSerial Communication for the STM Library             *
'* Notes   : Uncomment a line to declare a Terminal Baud Rate. (One only)      *
'******************************************************************************* 
' Uncomment a line to define a Terminal Baud Rate, and compile. (One only)
$ifdef _ProteusDebug_
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
'    $define _HSerialBaud_ 115200
$else
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
'    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
    $define _HSerialBaud_ 115200
$endif
'===============================================================================
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial_Clear  = On         ' Clear overflow automatically
'    Declare Hserial_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial_Baud = 9600
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial_Baud = 115200
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
'-------------------------------------------------------------------------------
(*
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial2_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial2_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial2_Clear  = On         ' Clear overflow automatically
'    Declare Hserial2_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial2_Baud = 9600
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial2_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial2_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial2_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial2_Baud = 115200
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
*)
'-------------------------------------------------------------------------------
'===============================================================================
' Choose the HSRSout command for the STM Library. (One only)
    $define _HRSOut HRSOut
'    $define _HRSOut HRSOut1
'    $define _HRSOut HRSOut2
'    $define _HRSOut HRSOut3
'    $define _HRSOut HRSOut4
'    $define _HRSOut HRSOut5   
'*******************************************************************************
'* Name    : State Machine Commands                                            *
'* Notes   : Uncomment the line to enable a STM Function                       *
'*******************************************************************************
' Uncomment the followed line to disable the terminal function to send strings
' for the STM Library only.
    $define _EnableTerminal_

' Uncomment the followed line to enable the ReturnSM function.
' Disabled = Default configuration.
'    $define _CheckReturnStateM_

' Uncomment the followed line to disable the Carriage Return before every state
' for the STM Library only. 
' Enabled = Default configuration.
'    $define _DisableCRBeforeState_

' Uncomment the followed line to enable some Timers
' All Enabled = Default configuration.
    $define _Timer10mS_
    $define _Timer1S_

' Uncomment the followed line to Synchronize the Main code with Timer 1mS.
' All Disabled = Default configuration.
'    $define _Synchronize1mS_
    $define _SynchronizeB1mS_
'    $define _Synchronize10mS_

' Uncomment the followed line to enable some Delays
' Enabled = Default configuration.
    $define _SMVDelay_

' User Delay1. Disabled = Default configuration.
'    $define _Delay1_    

' User Delay2. Disabled = Default configuration.
    $define _Delay2_   

' User Delay3. Disabled = Default configuration.
'    $define _Delay3_

' (For DEBUG) Uncomment the followed line to insert a state number in every module.
' Enabled = Default configuration.
'    $define _DebugStates_

' Uncomment the followed line to enable another States Machine2 in Background
' All Disabled = Default configuration.
    $define _StatesMachine2_
'    $define _SM2VDelay_
'    $define _TimeCounter2_

'-------------------------------------------------------------------------------
    ' Library for the States Machine system.
    Include "D:\MyIncFiles\STMachine00.inc"
'*******************************************************************************
'*******************************************************************************
'* Name    : High Interrupt_Handler                                            *
'* Purpose : Generate a 1mS interrupt                                          *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using the Timer2 & PR2 it is more easy.                           *
'*******************************************************************************     
    On_Hardware_Interrupt GoTo Interrupt_Handler
    GoTo STM_START
'-------------------------------------------------------------------------------
'Interrupt Handler.
    Declare Reminders = OFF
Interrupt_Handler:
    Context Save
    '---------------------------------------------------------------------------
    If PIR1Bits_TMR2IF = 1 Then          ' Check if this is a timer2 interrupt?
        $ifdef _PinsTest_
        Toggle Test1
        $endif
        $ifdef _Synchronize1mS_
        F_Timer1mS = 1                  ' Set a Flag every 1mS
        $endif
        $ifdef _SynchronizeB1mS_
        F_SMMain1mS = 1                 ' Set a Flag every 1mS
        $endif
        PIR1Bits_TMR2IF = 0             ' Clear the Timer2 interrupt flag for next time.
        '-----------------------------------------------------------------------        
        $if _defined(_Timer10mS_) Or _defined(_Timer1S_)
        Inc Timer10mS
        If Timer10mS = 10 Then
            Timer10mS = 0           ' 100Hz Timer
            $ifdef _Synchronize10mS_
            F_Timer10mS = 1
            $endif
            $ifdef _Timer1S_
            Inc Timer500mS
            If Timer500mS = 50 Then
                Timer500mS = 0
                Toggle F_Timer500mS    ' 1 Hz Timer, to toggle some leds.
            EndIf 
            $endif
            ' Other Timers?
            ' Your code...
        EndIf
        $endif
        '-----------------------------------------------------------------------
        $ifdef _SMVDelay_
        ' Delay 1mS for the States.
        If F_SMVDelay = 1 Then           ' The VDelay is started.
            Dec SMDelayCounter          ' Decrements the SMDelayCounter every 1mS.
            If SMDelayCounter = 0 Then  ' Check if delay counter reaches 0.
                F_SMVDelay = 0           ' Delay END, clear the Vdelay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay1_
        ' Count every 1mS.
        If F_Delay1 = 1 Then            ' The Delay is started.
            Dec Delay1Counter           ' Decrements the DelayCounter every 1mS.
            If Delay1Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay1 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay2_
        ' Count every 1mS.
        If F_Delay2 = 1 Then            ' The Delay is started.
            Dec Delay2Counter           ' Decrements the DelayCounter every 1mS.
            If Delay2Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay2 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay3_
        ' Count every 1mS.
        If F_Delay3 = 1 Then            ' The Delay is started.
            Dec Delay3Counter           ' Decrements the DelayCounter every 1mS.
            If Delay3Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay3 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
    EndIf    
'-------------------------------------------------------------------------------
' Here the another user interrupt handler code....
' .......
' .......
' .......
'-------------------------------------------------------------------------------
END_INT:
'-------------------------------------------------------------------------------
    Context Restore                     ' Exit the interrupt handler and restore variables
    Declare Reminders = On
'*******************************************************************************
'*******************************************************************************
'* Name    : EEPROM Data                                                       *
'* Purpose : Write some strings in the EEPROM memory                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
E2p_AddressString1 EData "Testing the STATIC STATES MACHINE STM00 Scheduler",0

E2p_AddressString2 EData "using the Amicus18 Board,",0

E2p_AddressString3 EData "by Alberto Freixanet.",0
'******************************************************************************* 
STM_START:
'*******************************************************************************
' PLACE HERE the library files:
'*******************************************************************************
'* Name    : HRsout_K40.Inc                                                    *
'* Purpose : HRSout command for 1 or 2 stop bits                               *
'* Notes   :                                                                   *
'*******************************************************************************
' Library to use the HRSOut command with 2 stop bits to be compatible
' with the temrinal of the AGV bootloader.
    $define _DisableAllinterrupt_
'    $define _Disable2StopBits_
    Include "D:\MyIncFiles\HRsout_K40.inc"
'*******************************************************************************
'* Name    : ORG_SyncBlock.Inc                                                 *
'* Purpose : Generate an ORG command syncronized with the Erase Blocks         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : For Cdata Tables                                                  *
'******************************************************************************* 
    Include "D:\MyIncFiles\ORG_SyncBlock_K20.inc"
' Syntax: ORG_EBlock(pAddress)  
'===============================================================================

'###MAIN CODE###################################################################
STMAIN:
'*******************************************************************************
'* Name    : Init some variables for the PIC                                   *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    WDTCON.0 = 0            ' Disable the Watchdog
    INTCON = 0              ' Disable All interrupts
    TBLPTRU = 0
    INTCON2Bits_RBPU = 1    ' Disable internal PullUp
    WPUB = 0                ' Pullups disabled in PORTB
    T0CON = 0

' Init the PORTS
'    ANSEL = 0
'    ANSELH = 0
'    CM1CON0 = 0
'    CM2CON0 = 0
    PORTA = 0               ' Clear all ports
    LATA = 0
    PORTB = 0
    LATB = 0    
    PORTC = 0
    LATC = 0
    Input PORTC.7
    Output PORTC.6
'*******************************************************************************
'* Name    :                                                                   *
'* Purpose : Initialize some variables of the States Machine                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    SM_UserFlags = 0
'-------------------------------------------------------------------------------
     InitStateMachine()
'###############################################################################
'#### STATE MACHINE STARTS #####################################################
' The Main code Start Here:
StateMachineInit:
'*******************************************************************************
'* Name    : NextState(0)                                                      *
'* Purpose : Initialize the State Machine.                                     *
'* Notes   : Start the first state.                                            *
'*******************************************************************************
    NextState(0)
'*******************************************************************************
'* Name    : StateMachineInit                                                  *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   : The ReturnSM() goes Here:                                         *
'*******************************************************************************
StateMachineStart:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : USER Functions                                                    *
'* Purpose : Write some Timing functions                                       *
'* Notes   : Using Timing flags only                                           *
'*******************************************************************************
' RUN Timer function: 
    $ifdef _Synchronize1mS_
    If F_Timer1mS = 1 Then
        F_Timer1mS = 0
        ' Your Code...
    EndIf
    $endif
'-------------------------------------------------------------------------------
    $ifdef _Synchronize10mS_
    If F_Timer10mS = 1 Then
        F_Timer10mS = 0
        ' Your Code...
    EndIf
    $endif
'-------------------------------------------------------------------------------
' RUN User Function1: Toggle the LED8 every 1/2 second.
    If F_UserFunction1 = 1 Then
        LED8 = F_Timer500mS
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function2: Clear LED9 after a delay..
    If F_UserFunction2 = 1 Then
        If F_Delay2 = 0 Then
            LED9 = 0
            F_UserFunction2 = 0
        EndIf
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function3:


'*******************************************************************************   
'*******************************************************************************
'* Name    : States Machine Scheduler                                                          
'* Purpose : Run the Scheduler 2 if State2Index > 0                   
'* Notes   :                                             
'===============================================================================
'  Running the States Machine2 in BackGround.
$ifdef _StatesMachine2_
    If State2Index > 0 Then
        GoTo StateMachine2Start 
    EndIf
$endif
' Return from States Machine2
ReturnStateMachine2:
'===============================================================================
    ' Running the Module Delay. The F_SMVDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SMVDelay_
    If F_SMVDelay = 1 Then
        GoTo StateMachineStart  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
    '===========================================================================
    ' Update the LABELS when you add a new States Machine Module.
    BranchL StateIndex,[STATE00,STATE01,STATE02,STATE03,STATE04,STATE05,STATE06,_
                        STATE07,STATE08,STATE09,STATE10,STATE11,STATE12,STATE13,_
                        STATE14,STATE15,STATE16]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex is OUT of RANGE.
    $ifdef _SMVDelay_
    F_SMVDelay = 0
    $endif
    $ifdef _EnableTerminal_
        '$ifdef _DebugStates_
        _HRSOut "STATE OUT OF RANGE: ", Dec StateIndex,CR,LF
        DelayMS 1000
        '$endif
    $endif
    '---------------------------------------------------------------------------
    ' ERROR in States Machine Variable Range. Reset the States Machine. 
    GoTo StateMachineInit  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################
'*******************************************************************************
'* Name    : STATE00                                                          
'* Purpose : Initialize the project in the terminal window                     
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : Start the first state.                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE00:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
   
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT0,AllChars,0) : HRSOut " STM00",CR,LF    ' "STATES MACHINE"
    HRSLStrg(TXT1,1)   ' "By A. Freixanet"
    '---------------------------------------------------------------------------
    IncState() 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE01                                                          
'* Purpose : Read the WDT config in memory map.                               
'* Input   : None                                                             
'* Output  : None                                                            
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim WDTdata As SMLVSByte1

' Define the Symbols used:
    Symbol _Config2h = $300003      ' Address in ROM of the WDT config, see the datasheet
'===============================================================================
STATE01:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT3,1)        ' "CONFIG FUSES: "
    HRSLStrg(TXT2,1)        ' Read the WDT config in memory map.
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

' Read the WDT config in memory map.
    EECON1 = %11000000              ' Access Configuration registers
    TBLPTRL = _Config2h & 255
    TBLPTRH = (_Config2h >> 8) & 255
    TBLPTRU = (_Config2h >> 16) & 255
    Tblrd*                          ' Read one memory position.  
    WDTdata = TABLAT                ' Copy the TABLAT SFR immediatly because it is cleared out of this routine??
    EECON1 = 0                      ' Disable Access the Configuration registers
    TBLPTRU = 0                     ' The HRSOut command of the compiler does not clear the "TBLPTRU = 0", then take care of that.
    '--------------------------------------------------------------------------- 
    $if (_device = _18F23K20) Or (_device = _18F24K20) Or (_device = _18F25K20) Or (_device = _18F26K20) Or (_device = _18F43K20) Or (_device = _18F44K20) Or (_device = _18F45K20) Or (_device = _18F46K20)
    WDTdata = WDTdata & 1
    If WDTdata = 1 Then
        HRSLStrg(TXT4,0)        ' "WDT enabled in hardware; SWDTEN bit disabled."
    Else
        HRSLStrg(TXT5,0)        ' "WDT controlled by the SWDTEN bit."
    EndIf
    $else
        $error "ERROR PIC!"
    $endif
    HRSOut CR
    '---------------------------------------------------------------------------
' Config Fuses:   BOREN = On        ' Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    RCONBits_SBOREN = 1
    If RCONBits_SBOREN = 1 Then
        HRSLStrg(TXT6,1)            ' "Brown-out Reset enabled!"
    Else
        HRSLStrg(TXT7,1)            ' "Brown-out Reset disabled!"
    EndIf
    '---------------------------------------------------------------------------
' Check the SWDTEN Bit.
    HRSLStrg(TXT8,1)                ' "Be carrefull the WDT is always active!"
    If WDTdata = 0 Then
        HRSLStrg(TXT9,0)            ' "After Reset the "

        If WDTCONBits_SWDTEN = 1 Then
            HRSLStrg(TXT10,1)       ' "SWDTEN Bit = 1 (error)"
        Else
            HRSLStrg(TXT11,1)       ' "SWDTEN Bit = 0 (good, by code)"
        EndIf
        WDTCONBits_SWDTEN = 1       ' Enable the Watchdog
        If WDTCONBits_SWDTEN = 1 Then
            HRSLStrg(TXT12,1)       ' "Now the SWDTEN Bit is set => Watchdog Enabled."
        Else
            HRSLStrg(TXT13,1)       ' "Now the SWDTEN Bit is Cleared => Watchdog Disabled."
        EndIf
    EndIf
    '---------------------------------------------------------------------------
    IncState() 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT14,1)    ' "WDT already checked!"
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE02                                                          
'* Purpose : Read the PIC Part Number                                        
'* Input   : None                                                            
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:
    Dim PICPartNumber As Word
    Dim PICRevision As Word

' Define the Local variables used in this state:
    Dim DataWord As SMLVSWord1

' Define the Symbols used:
    Symbol ID_ADDRESS = $3FFFFE     ' Write the ID address. Location of (DEVID1) in memory map, see the datasheet
'===============================================================================
STATE02:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT15,1)    ' "Read the PIC ID from Config fuse."
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

' Read the PIC ID from Config fuse.
    EECON1 = %11000000              ' Access Configuration registers    
    TBLPTRL = ID_ADDRESS & 255
    TBLPTRH = (ID_ADDRESS >> 8) & 255
    TBLPTRU = (ID_ADDRESS >> 16) & 255
    Tblrd*+                         ' perform table read with post-increment
    DataWord.LowByte = TABLAT
    Tblrd*+                         ' perform table read with post-increment
    DataWord.HighByte = TABLAT        
    TBLPTRU = 0                     ' Cleared for security
    EECON1 = 0                      ' Disable Access the Configuration registers
    '---------------------------------------------------------------------------
    ' Calculate the PIC Part Number & revision
    PICPartNumber = DataWord >> 5
    PICRevision = DataWord.LowByte & 31
    '---------------------------------------------------------------------------
    HRSLStrg(TXT16,0)           ' "Device = "
    Select PICPartNumber
        Case 263
            HRSLStrg(TXT17,0)   ' "PIC18F23K20"
        Case 261
            HRSLStrg(TXT18,0)   ' "PIC18F24K20"
        Case 259
            HRSLStrg(TXT19,0)   ' "PIC18F25K20"
        Case 257
            HRSLStrg(TXT20,0)   ' "PIC18F26K20"
        Case 262
            HRSLStrg(TXT21,0)   ' "PIC18F43K20"
        Case 260
            HRSLStrg(TXT22,0)   ' "PIC18F44K20"
        Case 258
            HRSLStrg(TXT23,0)   ' "PIC18F45K20"
        Case 256
            HRSLStrg(TXT24,0)   ' "PIC18F46K20"
    EndSelect
    HRSOut CR
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT25,1)       ' "PIC PartNumber already checked!"
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE03                                                            
'* Purpose : Print the characterics of the PIC                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                    
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE03:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT43,1)    ' "Read the PIC informations."
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT26,AllChars,0) : HRSOut Dec _xtal : HRSLStrg(TXT27,0) ' "FOSC: ", Dec _xtal," Mhz"

    $ifdef _InternalOSC_
    HRSLStrg(TXT28,1)       ' " Internal Oscillator "
    $else
    HRSLStrg(TXT29,1)       ' " Xtal Oscillator "
    $endif

    HRSLStrg(TXT30,AllChars,0) : HRSOut Dec PICPartNumber : HRSLStrg(TXT31,AllChars,0) : HRSOut Hex4 PICPartNumber ' ", Revision: ", Dec PICPartNumber, " / $", Hex2 PICPartNumber,CR,LF
    HRSLStrg(TXT32,AllChars,0) : HRSOut Dec3 PICRevision : HRSLStrg(TXT31,AllChars,0) : HRSOut Hex4 PICRevision : HRSOut CR  ' ", Revision: ", Dec PICRevision, " / $", Hex2 PICRevision,CR,LF
    HRSLStrg(TXT33,AllChars,0) : HRSOut Dec _block : HRSLStrg(TXT34,1)
    HRSLStrg(TXT35,AllChars,0) : HRSOut Dec ERASE_FLASH_BLOCKSIZE : HRSLStrg(TXT34,1)
    HRSLStrg(TXT36,AllChars,0) : HRSOut Dec _eeprom : HRSLStrg(TXT34,1)
    HRSLStrg(TXT37,AllChars,0) : HRSOut Dec _code : HRSLStrg(TXT34,1)
    HRSLStrg(TXT38,AllChars,0) : HRSOut Dec _ram : HRSLStrg(TXT34,1)
    HRSLStrg(TXT39,AllChars,0) : HRSOut Dec _bankAend,CR
    HRSLStrg(TXT40,AllChars,0) : HRSOut Dec _rambanks,CR
    HRSLStrg(TXT41,AllChars,0) : HRSOut Dec _uart,CR
    HRSLStrg(TXT42,AllChars,0) : HRSOut Dec _HSerialBaud_,CR
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    ' Write your code below
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT44,1)       ' "PIC checked!"
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE04                                                          
'* Purpose : READING THE ISER ID LOCS                                          
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim IDLoop As SMLVSByte1

' Define the Symbols used :
    Symbol _ID_LOCATION = $200000   ' Write the IDLOCS address. Eight memory locations (200000h-200007h) are designated, see the datasheet
'===============================================================================
STATE04:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT45,1)       ' "Read the USER ID LOCS."
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT46,0)               ' Reading the PIC ID: 
    EECON1 = %11000000              ' Access Configuration registers
    TBLPTRL = _ID_LOCATION & 255
    TBLPTRH = (_ID_LOCATION >> 8) & 255
    TBLPTRU = (_ID_LOCATION >> 16) & 255
    For IDLoop = 0 To 7             ' Start the loop
        Tblrd*+                     ' Read one memory position.
        HRSOut TABLAT
    Next  
    EECON1 = 0                      ' Disable read the Configuration registers
    TBLPTRU = 0 ' The HRSOut command of the compiler does not clear the "TBLPTRU = 0", then take care of that.
                ' The HRSOut command can crash if the TBLPTRU SFR is not cleared.
    HRSOut CR
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT47,1)       ' ID LOCS checked.
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE05                                                           
'* Purpose : Send a String To the terminal read from the data eeprom memory.   
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : Using the new command: HRSE2PStrg(Eeprom Address)                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used :

'===============================================================================
STATE05:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT48,1)       ' "START READ EEPROM Strings:"
    '##-END INIT-###############################################################
    StateInitEnd()    
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ' Send 1st String.
    HRSE2PStrg(E2p_AddressString1,AllChars,1)
    ' Send 2nd String.
    HRSE2PStrg(E2p_AddressString2,AllChars,1)
    ' Send 3rd String.
    HRSE2PStrg(E2p_AddressString3,AllChars,1)
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT49,1)       ' "END READ EEPROM Strings:" 
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd() 
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE06                                                           
'* Purpose : Send some strings to the Terminal                                 
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE06:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT50,1)       ' "Strings read from the ROM memory." 
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT51,1)   ' "Testing the Amicus18 Board."
    HRSLStrg(TXT54,1)   ' "Using 8 push buttons and 8 LEDs.
    HRSLStrg(TXT56,1)   ' "LED8 & LED9 for other Tests"
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE07  [SM_ButtonsOff]                                                       
'* Purpose : Waiting until all Buttons depressed (OFF).                        
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : Read all Buttons and save informations in a virtual PORT.        
'===============================================================================
' Define the Global variables used in this state:
    Dim ButtonsVirtualPORT As Byte
    Dim SW0 As ButtonsVirtualPORT.0
    Dim SW1 As ButtonsVirtualPORT.1    
    Dim SW2 As ButtonsVirtualPORT.2    
    Dim SW3 As ButtonsVirtualPORT.3
    Dim SW4 As ButtonsVirtualPORT.4    
    Dim SW5 As ButtonsVirtualPORT.5    
    Dim SW6 As ButtonsVirtualPORT.6
    Dim SW7 As ButtonsVirtualPORT.7  
' Define the Local variables used in this state:

' Define the Symbols used :

'===============================================================================
STATE07:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT52,AllChars,1)      ' "Waiting All Buttons depressed!"
    '##-END INIT-###############################################################
    StateInitEnd()   ' Module synchronized with timing 1mS.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtonsPORT_Sub   ' Init & Read all Buttons.

    ' Waiting All Buttons OFF (All Buttons have a Pull-up resistor).
    If ButtonsVirtualPORT = 255 Then
        NextStateDelay(30,SM_ReadButtons)   ' Delay 30mS.
        NextState2(SM2_Message2)            ' Call the State Machine2 in Background
    EndIf                                   ' when VDelay is running.

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)    ' 30 mS delay works like a debounce
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE08  [SM_ReadButtons]
'* Purpose : Read all Buttons
'* Input   : None
'* Output  : None                                                             
'* Notes   : Read the Buttons with debounce system.                                                                 
'===============================================================================
' Define the Global variables used in this state:
    Dim KEYnOld As Byte
    Dim KEYCounter As Byte
    Dim PORTATemp As Byte
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE08:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT58,1)       ' "Waiting a Button pressed!"
    KEYnOld = 0             ' Initialize parameters for debouncing.
    KEYCounter = 0
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtons2PORT_Sub                  ' Read all Buttons.

    If ButtonsVirtualPORT < 255 Then
        If KEYnOld = ButtonsVirtualPORT Then    ' Some debounce system
            Inc KEYCounter
            If KEYCounter = 4 Then              ' 4 + 1 readings necessary.
                KEYCounter = 0
                ' Check Button 0.
                If SW0 = 0 Then
                    NextState(SM_LED0)
                EndIf
                ' Check Button 1.
                If SW1 = 0 Then
                    NextState(SM_LED1)
                EndIf            
                ' Check Button 2.
                If SW2 = 0 Then
                    NextState(SM_LED2)
                EndIf
                ' Check Button 3.
                If SW3 = 0 Then
                    NextState(SM_LED3)
                EndIf            
                ' Check Button 4.
                If SW4 = 0 Then
                    NextState(SM_LED4)
                EndIf
                ' Check Button 5.
                If SW5 = 0 Then
                    NextState(SM_LED5)
                EndIf            
                ' Check Button 6.
                If SW6 = 0 Then
                    NextState(SM_LED6)
                EndIf
                ' Check Button 7.
                If SW7 = 0 Then
                    NextState(SM_LED7)
                EndIf   
            EndIf
        Else
            KEYCounter = 0
        EndIf
        KEYnOld = ButtonsVirtualPORT
    Else
        KEYCounter = 0
    EndIf
    
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)    ' Adjust some Debounce time 30mS.
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StartBeep() ' Generate a pulse (Beep) of 0,250 second  for every Button pressed.
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$    
    StateOutEnd()
'===============================================================================
    ReturnSM()
'===============================================================================
'* Name    : ReadButtonsPORT_Sub                                              
'* Called From: SM_ButtonsOff, SM_ReadButtons                                     
'* Purpose : Read all Buttons                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : 6 Buttons in PORTB, 2 Buttons in PORTA                           
'===============================================================================  
' Define the Global variables used in this state:

' Define the Symbols used :

'===============================================================================
ReadButtonsPORT_Sub:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    ANSEL = 0                       ' PORTA digital
    ANSELH = 0                      ' PORTB digital
    TRISA = TRISA & %11110000       ' Leds outputs PORTA
    TRISC = TRISC & %11000000       ' Leds outputs PORTC   
    TRISB = TRISB | %00111111       ' PORTB all inputs
    TRISA = TRISA | %00110000       ' SW6, SW7 for input.
    DelayUS 100
ReadButtons2PORT_Sub:
    ButtonsVirtualPORT = PORTB      ' Read SW0 to SW5
    ButtonsVirtualPORT.6 = PORTA.4  ' Read SW6
    ButtonsVirtualPORT.7 = PORTA.5  ' Read SW7
    Return
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE09 [SM_LED0]                                          
'* Purpose : Set or Clear LED0                                             
'* Input   : None                                                           
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE09:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    StartFunction1()' Blinking a LED.
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT59,0)           ' "SW0 detected!"
    If LED0 = 0 Then
        Set LED0
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED0
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT62,1)           ' " LED0"

    NextState(SM_ButtonsOff)    ' Come back reading buttons

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)             ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    NextState2(SM2_Message1)    ' Call the State Machine2
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE10  [SM_LED1]                                                         
'* Purpose : Set or Clear LED1                                                 
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE10:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd() 
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT63,0)           ' "SW1 detected!"
    If LED1 = 0 Then
        Set LED1
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED1
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT64,1)           ' " LED1"

    NextState(SM_ButtonsOff)    ' Come back reading buttons

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    NextState2(SM2_Message1)    ' Call the State Machine2
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE11  [SM_LED2]                                                        
'* Purpose : Set or Clear LED2                                                
'* Input   : None                                                             
'* Output  : None                                                             
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE11:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd() 
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT65,0)           ' "SW2 detected!"
    If LED2 = 0 Then
        Set LED2
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED2
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT66,1)           ' " LED2"

    NextState(SM_ButtonsOff)    ' Come back reading buttons

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    NextState2(SM2_Message1)    ' Call the State Machine2
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE12 [SM_LED3]                                                          
'* Purpose : Set or Clear LED3                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
 
'===============================================================================
STATE12:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT67,0)           ' "SW3 detected!"
    If LED3 = 0 Then
        Set LED3
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED3
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT68,1)           ' " LED3"

    NextState(SM_ButtonsOff)    ' Come back reading buttons

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    NextState2(SM2_Message1)    ' Call the State Machine2
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE13 [SM_LED4]                                                         
'* Purpose : Set or Clear LED4                                                 
'* Input   : None                                                             
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE13:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()    
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT69,0)           ' "SW4 detected!"
    If LED4 = 0 Then
        Set LED4
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED4
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT70,1)           ' " LED4"

    NextState(SM_ButtonsOff)    ' Come back reading buttons

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    NextState2(SM2_Message1)    ' Call the State Machine2 
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE14 [SM_LED5]                                                          
'* Purpose : Set or Clear LED5                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE14:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT71,0)           ' "SW5 detected!"
    If LED5 = 0 Then
        Set LED5
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED5
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT72,1)           ' " LED5"

    NextState(SM_ButtonsOff)    ' Come back reading buttons           

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    NextState2(SM2_Message1)    ' Call the State Machine2
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE15 [SM_LED6]                                                           
'* Purpose : Set or Clear LED6                                                 
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE15:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT73,0)           ' "SW6 detected!"
    If LED6 = 0 Then
        Set LED6
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED6
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT74,1)           ' " LED6"

    NextState(SM_ButtonsOff)    ' Come back reading buttons            

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    NextState2(SM2_Message1)    ' Call the State Machine2
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE16 [SM_LED7]                                                           
'* Purpose : Set or Clear LED7                                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                    
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE16:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT75,0)           ' "SW7 detected!"
    If LED7 = 0 Then
        Set LED7
        HRSLStrg(TXT60,0)       ' ", Set"
    Else
        Clear LED7
        HRSLStrg(TXT61,0)       ' ", Clear"
    EndIf
    HRSLStrg(TXT76,1)           ' " LED7"

    NextState(SM_ButtonsOff)    ' Come back reading buttons           

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StopFunction1()            ' Clear the Function1 designed by the USER
    NextState2(SM2_Message1)   ' Call the State Machine2
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE17 []                                                        
'* Purpose :                                                                 
'* Input   : None                                                            
'* Output  : None                                                           
'* Notes   :                                                                 
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE17:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE18 []                                                         
'* Purpose :                                                                 
'* Input   : None                                                            
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE18:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE19                                                          
'* Purpose :                                                                 
'* Input   : None                                                            
'* Output  : None                                                           
'* Notes   :                                                               
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE19:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

          
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************
'###############################################################################
'#### STATE MACHINE2 STARTS ####################################################
$ifdef _StatesMachine2_
' The Main code Start Here:
'*******************************************************************************
'* Name    : StateMachine2Start                                                *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   :                                                                   *
'*******************************************************************************
StateMachine2Start:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : States Machine2 Scheduler                                                          
'* Purpose : Running the code of all modules.                   
'* Notes   : Do not forget update the State Label.                                            
'===============================================================================
    ' Running the Module2 Virtual Delay. The F_SM2VDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SM2VDelay_
    If F_SM2VDelay = 1 Then
        GoTo ReturnStateMachine2  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
'===============================================================================
    ' Update the LABELS when you add a new States Machine Module.
    BranchL State2Index,[STATE100,STATE101,STATE102]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex2 is OUT of RANGE.
    $ifdef _SM2VDelay_
    F_SM2VDelay = 0     ' Clear any VDelay2
    $endif
    $ifdef _EnableTerminal_
    _HRSOut "STATE MACHINE2 OUT OF RANGE: ", Dec State2Index,13,10
    DelayMS 1000
    $endif
    NextState2(0)
    ' ERROR in States Machine2 Variable Range. Reset the States Machine2. 
    GoTo ReturnStateMachine2  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################
'*******************************************************************************
'* Name    : STATE100  []       
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : A not used Label is needed For the Scheduler.                                                            
'===============================================================================
STATE100:   ' [SM2_Init]
    ' Nothing to do.
    ' Return to States Machine 1.
    ReturnSM1()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE101 [SM2_Message1]        
'* Purpose : Print a message to the Terminal in Background                                                      
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : Module in Test                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE101:
'===============================================================================
    StateInit2()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInit2End()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

'    HRSOut "From State Machine2; called by SM1 Module", Dec StateIndexOld,CR,LF
'    HRSOut "From State Machine2; GoTo SM1 Module", Dec StateIndex,CR,LF    

    HRSLStrg(TXT81,AllChars,0) : HRSOut Dec StateIndexOld,CR,LF  ' "From State Machine2; called by SM1 Module"
    HRSLStrg(TXT82,AllChars,0) : HRSOut Dec StateIndex,CR,LF     ' "From State Machine2; GoTo SM1 Module"
'    HRSOut "StateIndex ", Dec StateIndex,CR,LF 
    NextState2(SM2_Init)      

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    SM2StartDelayMS(0)
'===============================================================================
    StateOut2(0)        ' Disable the Time Counter (NO code).
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE102 [SM2_Message2]        
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : Module in Test                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE102:
'===============================================================================
    StateInit2()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInit2End()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT81,AllChars,0) : HRSOut Dec StateIndexOld,CR,LF  ' "From State Machine2; called by SM1 Module"
'    HRSOut "StateIndex ", Dec StateIndex,CR,LF 
    NextState2(SM2_Init)
           
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    SM2StartDelayMS(0)
'===============================================================================
    StateOut2(0)        ' Disable the Time Counter (NO code).
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************


'*******************************************************************************
'*******************************************************************************
' End of States Machine2
$endif  
'*******************************************************************************

'###############################################################################
'###############################################################################

'*** SUBROUTINES ***************************************************************
'*******************************************************************************
' Subroutines of the project.
''*******************************************************************************
''* Name    : ReadEEPString_Sub                                                 *
''* Purpose : Read a String written in the eeprom memory.                       *
''* Input   : None                                                              *
''* Output  : None                                                              *
''* Notes   : Use Bytes System only for variables                               *
''*******************************************************************************
'' Define the Global variables used in this state:

'' Define the Symbols used :

''===============================================================================


'*******************************************************************************
'* Name    :                                               
'* Purpose : Read the state all buttons of the Board                        
'*         : To the terminal.                                                  
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                  
'=============================================================================== 
' Define the Global variables used in this state:

' Define the Symbols used:

'===============================================================================

'    Return
'*******************************************************************************
'* Name    :                                        
'* Purpose :                       
'* Input   : None                                                             
'* Output  : None                                                              
'* Notes   :                                                                   
'=============================================================================== 
' Define the Global variables used in this state:

' Define the Symbols used:



'===============================================================================

'===============================================================================



'*******************************************************************************
'* Name    : STM_Strings00.Inc                                               
'* Purpose : CData Table for Strings or Datas                                 
'* Input   : None                                                             
'* Output  : None                                                             
'* Notes   : Write the Tables at top of memory syncronized with Erase Block    
'*         : The Cdata table could have 1600 Bytyes                           
'*         : Table of Strings of the program                                   
'===============================================================================
'    ORG_EBlock(_MAXMEM - 1600)
    Include "D:\MyIncFiles\STM_Strings00.Inc"
'*******************************************************************************
' Write some static data to the ID Locations.
' STM00V10
Asm
__IDLOCS   __IDLOC0,0x53
__IDLOCS   __IDLOC1,0x54
__IDLOCS   __IDLOC2,0x4D
__IDLOCS   __IDLOC3,0x30
__IDLOCS   __IDLOC4,0x30
__IDLOCS   __IDLOC5,0x56
__IDLOCS   __IDLOC6,0x31
__IDLOCS   __IDLOC7,0x30
EndAsm
'*******************************************************************************
'*** END OF FILE ***************************************************************
'*******************************************************************************

                
