'****************************************************************
'*  Name    : STM03B.bas                                        *
'*  Project : Testing the State Machine Template                *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) February 2017 [A. Freixanet 2017]   *
'*          : All Rights Reserved                               *
'*  Date    : 03/04/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   : Using the AMICUS18 Development Board              *
'*          : CPU : PIC18F25K20 with Xtal 16Mhz, with 4xPLL     *
'* Terminal Amicus      : Used for testing                      *
'* Powered by PROTON DEVELOPMENT SUITE COMPILER V3.5.9.3        *
'* Testing a 4x3 Keypad with the InkeyX command                 *
'* This code is prepared to download by the AGV BootloaderV4.1  *
'****************************************************************
'
'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'*==============================================================================
' Testing the CODE by Proteus
    $define _ProteusDebug_
'===============================================================================
' Choose the Bootloader you are using for the Amicus18 Board (real hardware).
' CHOOSE ONLY ONE.
$ifndef _ProteusDebug_

'    $define _AmicusBootloader_
    $define _LSM_AGV_BootloaderV41_

$endif
'===============================================================================

    Device = 18F25K20

    $ifdef _ProteusDebug_
    ' Settings CPU Proteus at 4Mhz (with settings fuses)
    Declare Xtal = 16
    $else
    ' Settings CPU Amicus18 Board at 16Mhz (with settings fuses)
    Declare Xtal = 64
    $endif
'*******************************************************************************
'* Name    : Compiler Declare                                                  *
'* Purpose : Configuration of the compiler                                     *
'* Notes   :                                                                   *
'*******************************************************************************
    $if _defined(_LSM_AGV_BootloaderV41_) And _defined(_AmicusBootloader_)
        $error "ONLY CHOOSE ONE BOOTLOADER"
    $endif

    ' More security using the Bootloader in the Low Side of ROM memory (only for real piece).
    $ifdef _LSM_AGV_BootloaderV41_
        Declare PROTON_START_ADDRESS = 2048
    $endif
    '---------------------------------------------------------------------------
    Declare Eeprom_Address = $F00000
    Declare Optimiser_Level = 2
    Declare Dead_Code_Remove = On
    Declare Create_Coff = On
    Declare Watchdog = On
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
    Declare Bootloader = Off
    Declare Show_System_Variables = On
    Declare MemWrite_Int_Control = 1
    $if 65537 < _code
    Declare Access_Upper_64K = On
    $endif
    Declare Keypad_Port PORTB
'===============================================================================
$ifdef _ProteusDebug_
'-------------------------------------------------------------------------------
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	 ;Oscillator Switchover mode disabled
    PWRT = On	  ;PWRT enabled
    BOREN = On	 ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	  ;VBOR set to 2.2 V nominal
    WDTEN = OFF	    ;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	    ;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	     ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	  ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = OFF	;Boot block (000000-0007FFh) not code-protected
    CPD = OFF	;Data EEPROM not code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
'-------------------------------------------------------------------------------
$else
'-------------------------------------------------------------------------------
$ifdef _AmicusBootloader_
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	 ;Oscillator Switchover mode disabled
    PWRT = On	  ;PWRT enabled
    BOREN = On	 ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	  ;VBOR set to 2.2 V nominal
    WDTEN = OFF	    ;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	    ;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	     ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	  ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = OFF	;Boot block (000000-0007FFh) not code-protected
    CPD = OFF	;Data EEPROM not code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
$else
' Full Boot Block protected for the Low Side ROM Bootloader V4.1.
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	;Fail-Safe Clock Monitor disabled
    IESO = OFF	;Oscillator Switchover mode disabled
    PWRT = On	;PWRT enabled
    BOREN = On	;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	;VBOR set to 2.2 V nominal
    WDTEN = OFF	;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	;Stack full/underflow will cause Reset
    LVP = OFF	;Single-Supply ICSP disabled
    XINST = OFF	;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = On	;Boot block (000000-0007FFh) code-protected
    CPD = On	;Data EEPROM code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = On	;Boot Block (000000-0007FFh) write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = On	;Boot Block (000000-0007FFh) protected from table reads executed in other blocks
Config_End
$endif
'-------------------------------------------------------------------------------
$endif
'*******************************************************************************
'* Name    : LCD                                                               *
'* Purpose : Declare the LCD pins                                              *
'* Notes   : Configuration of the LCD for the AMicus18 Board.                  *
'******************************************************************************* 
' Configuration of the LCD for the AMicus18 Board.
'    Declare LCD_DTPin = PORTA.0         ' LCD's Data lines (D0 to D3)
'    Declare LCD_ENPin = PORTC.5         ' LCD's EN line
'    Declare LCD_RSPin = PORTC.4         ' LCD's RS line
'    Declare LCD_Interface = 4           ' 4-bit interface to LCD
'    Declare LCD_Lines = 2               ' LCD contains 2 lines
'    Declare LCD_DataUs = 50             ' Time to wait after print a data To LCD
'    Declare LCD_CommandUs = 2000        ' Time to wait after print a command to LCD
'    Declare LCD_Type = Alphanumeric     ' LCD type is alphanumeric
'    Symbol __LCD_CharsLenght = 16       ' LCD characters lenght.
'*******************************************************************************
'* Name    : Variables & Constants                                             *
'* Purpose : Declare the Variables or Constants                                *
'* Notes   : The local variables are declared for this State Machine file only *
'* Rules   : If the Variable is used once then get Local Variable.             *
'*         : If the Variable is used several times in a large loop in STM1     *
'*         : with STM2 or in others modules then get a Global Variable.        *
'******************************************************************************* 
' Definition of local Bytes for Main code only
$ifndef _SMLVBS_Block1_
    $define _SMLVBS_Block1_
    Dim SMLVSByte1 As Byte System     ' Local Variable System Byte1
    Dim SMLVSByte2 As Byte System     ' Local Variable System Byte2
    Dim SMLVSByte3 As Byte System     ' Local Variable System Byte3
    Dim SMLVSByte4 As Byte System     ' Local Variable System Byte4
$endif
' If you need more local Byte Variables, uncomment this block.
'$ifndef _SMLVBS_Block2_
'    $define _SMLVBS_Block2_
'    Dim SMLVSByte5 As Byte System     ' Local Variable System Byte1
'    Dim SMLVSByte6 As Byte System     ' Local Variable System Byte2
'    Dim SMLVSByte7 As Byte System     ' Local Variable System Byte3
'    Dim SMLVSByte8 As Byte System     ' Local Variable System Byte4
'$endif

' Definition of local Words For Main Code only
$ifndef _SMLVWS_Block1_
    $define _SMLVWS_Block1_
    Dim SMLVSWord1 As Word System     ' Local Variable System Word1
    Dim SMLVSWord2 As Word System     ' Local Variable System Word2
$endif
' If you need more local Word Variables, uncomment this block.
'$ifndef _SMLVWS_Block2_
'    $define _SMLVWS_Block2_
'    Dim SMLVSWord3 As Word System     ' Local Variable System Word1
'    Dim SMLVSWord4 As Word System     ' Local Variable System Word2
'$endif

' Definition of local DWords For Main Code only
'$ifndef _SMLVDWS_Block1_
'    $define _SMLVDWS_Block1_
'    Dim SMLVSDWord1 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord2 As DWord System     ' Local Variable System Word2
'$endif
' If you need more local Dword Variables, uncomment this block.
'$ifndef _SMLVDWS_Block2_
'    $define _SMLVDWS_Block2_
'    Dim SMLVSDWord3 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord4 As DWord System     ' Local Variable System Word2
'$endif

' Definition of local bits
'$ifndef _LVSBitS_Block1_
'    $define _LVSBitS_Block1_
'    Dim LVSBitsA As Byte System     ' Local Variable System byte
'$endif
'-------------------------------------------------------------------------------
' Global Bits for the USER
    Dim SM_UserFlags As Byte System
    Dim F_UserFunction1 As SM_UserFlags.0 
    Dim F_UserFunction2 As SM_UserFlags.1
    Dim F_UserFunction3 As SM_UserFlags.2
    Dim F_UserFunction4 As SM_UserFlags.3
    Dim F_UserFunction5 As SM_UserFlags.4
    Dim F_UserFunction6 As SM_UserFlags.5        
    Dim F_UserFunction7 As SM_UserFlags.6
    Dim F_UserFunction8 As SM_UserFlags.7
    
'-------------------------------------------------------------------------------
' Definition of the LEDS for Amicus18.
    Symbol LED0 = LATC.0
    Symbol LED1 = LATC.1
    Symbol LED2 = LATC.2
    Symbol LED3 = LATC.3
    Symbol LED4 = LATA.4
    Symbol LED5 = LATA.5
    Symbol LED6_7 = LATB.0
'*******************************************************************************
'* Name    : Language                                                          *
'* Purpose : Define one language for this project                              *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : One language must be enabled                                      *
'*******************************************************************************            
    $define _English_
'    $define _Spanish_
'    $define _French_ 
'*******************************************************************************
'* Name    : Write the ARRAYs in BANK0 and upward                              *
'* Purpose : Define manually a Dummy Array                                     *
'* Notes   : Using a Dummy Byte as reference                                   *
'******************************************************************************* 
'    Dim MyDummyByte As Byte     ' This byte is to calculate the position of the Arrays

'    ' After last compiling, verify the address (in asm file) of the variable "MyDummyByte" 
'    ' and update the AddressofMyDummyByte value.
'    $define AddressofMyDummyByte 52

'    $ifdef _bankAend
'        $if AddressofMyDummyByte < _bankAend
'            $define DummyArray_Lenght _bankAend - AddressofMyDummyByte + 1
'            Dim DummyArray[DummyArray_Lenght] As Byte  
'        $endif
'    $else
'        $error "The _bankAend parameter is absent from the .def file of the PDS!"
'    $endif
'===============================================================================
' Bits definition of the PIC18F25K20.
'
    Include "D:\MyIncFiles\SYS_18FXXK20.inc"
'*******************************************************************************
'* Name    : State machine numbers                                             *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM_Init 0               ' STATE00
    $define SM_ButtonsOff 7         ' STATE07
    $define SM_ReadKeypad 8         ' STATE08
    $define SM_Set_LED0 9           ' STATE09
    $define SM_Clear_LED0 10        ' STATE10
    $define SM_Set_LED1 11          ' STATE11
    $define SM_Clear_LED1 12        ' STATE12
    $define SM_Set_LED2 13          ' STATE13
    $define SM_Clear_LED2 14        ' STATE14
    $define SM_Set_LED3 15          ' STATE15
    $define SM_Clear_LED3 16        ' STATE16
    $define SM_Toggle_LED5 17       ' STATE17

'*******************************************************************************
'* Name    : State machine2 numbers                                            *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM2_Init 0              ' STATE00
'    $define SM2_PrintLCDLine2 1     ' STATE01
'    $define SM2_PrintLCDLine1 2     ' STATE02
'*******************************************************************************
'* Name    : USER FUNCTION 1 (only Meta Macro, no Subroutine)                  *
'* Purpose : Toggle the LED5                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'*******************************************************************************  
    $define StartFunction1() F_UserFunction1 = 1

    $define StopFunction1() F_UserFunction1 = 0 : LED5 = 0   

'*******************************************************************************
'* Name    : USER FUNCTION 2 (only Meta Macro, no Subroutine)                  *
'* Purpose : Set the LED4 for 250 mS                                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'******************************************************************************* 
    $define StartBeep() '
    F_UserFunction2 = 1 '
    LED4 = 1            '
    StartUserDelay2(250)

'*******************************************************************************
'* Name    : USER FUNCTION 3 (only Meta Macro, no Subroutine)                  *
'* Purpose : Set the LED6/LED7 for 250 mS                                      *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'******************************************************************************* 
    $define StartFunction3() F_UserFunction3 = 1
    $define StopFunction3() F_UserFunction3 = 0 : Input LED6_7

'*******************************************************************************
'* Name    : USER FUNCTION 4 (only Meta Macro, no Subroutine)                  *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'******************************************************************************* 


'*******************************************************************************
'* Name    : Enable the Library Commands inside the STMachine00.Inc file       *
'* Notes   :                                                                   *
'*******************************************************************************
' Uncomment the followed line to insert the Keypad option.
    $define _Disable_Pullups_
'    $define _4x4KEYPAD_
    $define _4x3KEYPAD_
'    $define _4x2KEYPAD_
'-------------------------------------------------------------------------------
' Others States Machine libraries.
    $define _HRSE2PStrg_
'    $define _Manchester_
'    $define _MidPoint_
'    $define _MedianFilter_
'    $define _BubbleSort_
'    $define _GetParity_
'    $define _RotateBits_
'    $define _BinaryTo3BCD_
'    $define _BCD2ToBinary_
'    $define _WordTo5BCD_
'    $define _DwordArray_
'    $define _CountUntil_
'    $define _ArrayROL_
'    $define _ArrayROR_
'    $define _ArrayROLR_
'    $define _ArrayRORR_
'    $define _ArrayBit_
'    $define _CRC16_
'*******************************************************************************
'* Name    : HSerial                                                           *
'* Purpose : Declare the HSerial Communication for the STM Library             *
'* Notes   : Uncomment a line to declare a Terminal Baud Rate. (One only)      *
'******************************************************************************* 
' Uncomment a line to define a Terminal Baud Rate, and compile. (One only)
$ifdef _ProteusDebug_
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
'    $define _HSerialBaud_ 115200
$else
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
'    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
    $define _HSerialBaud_ 115200
$endif
'===============================================================================
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial_Clear  = On         ' Clear overflow automatically
'    Declare Hserial_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial_Baud = 9600
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial_Baud = 115200
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
'-------------------------------------------------------------------------------
(*
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial2_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial2_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial2_Clear  = On         ' Clear overflow automatically
'    Declare Hserial2_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial2_Baud = 9600
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial2_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial2_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial2_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial2_Baud = 115200
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
*)
'-------------------------------------------------------------------------------
'===============================================================================
' Choose the HSRSout command for the STM Library. (One only)
    $define _HRSOut HRSOut
'    $define _HRSOut HRSOut1
'    $define _HRSOut HRSOut2
'    $define _HRSOut HRSOut3
'    $define _HRSOut HRSOut4
'    $define _HRSOut HRSOut5
'*******************************************************************************
'* Name    : State Machine Commands                                            *
'* Notes   : Uncomment the line to enable a STM Function                       *
'*******************************************************************************
' Uncomment the followed line to disable the terminal function to send strings
' for the STM Library only.
    $define _EnableTerminal_

' Uncomment the followed line to enable the ReturnSM function.
' Disabled = Default configuration.
'    $define _CheckReturnStateM_

' Uncomment the followed line to disable the Carriage Return before every state
' for the STM Library only. 
' Enabled = Default configuration.
'    $define _DisableCRBeforeState_

' Uncomment the followed line to enable some Timers
' All Enabled = Default configuration.
    $define _Timer10mS_
    $define _Timer1S_

' Uncomment the followed line to Synchronize the Main code with Timer 1mS.
' All Disabled = Default configuration.
'    $define _Synchronize1mS_
'    $define _SynchronizeB1mS_
'    $define _Synchronize10mS_


' Uncomment the followed line to enable some Delays
' Enabled = Default configuration.
    $define _SMVDelay_

' User Delay1. Disabled = Default configuration.
'    $define _Delay1_    

' User Delay2. Disabled = Default configuration.
    $define _Delay2_

' User Delay3. Disabled = Default configuration.
'    $define _Delay3_
    
' (For DEBUG) Uncomment the followed line to insert a state number in every module.
' Enabled = Default configuration.
'    $define _DebugStates_

' Uncomment the followed line to enable another States Machine2 in Background
' All Disabled = Default configuration.
'    $define _StatesMachine2_
'    $define _SM2VDelay_
'    $define _TimeCounter_

'-------------------------------------------------------------------------------
    ' Library for the States Machine system.
    Include "D:\MyIncFiles\STMachine00.inc"
'*******************************************************************************
'*******************************************************************************
'* Name    : High Interrupt_Handler                                            *
'* Purpose : Generate a 1mS interrupt                                          *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using the Timer2 & PR2 it is more easy.                           *
'*******************************************************************************     
    On_Hardware_Interrupt GoTo Interrupt_Handler
    GoTo STM_START
'-------------------------------------------------------------------------------
'Interrupt Handler.
    Declare Reminders = OFF
Interrupt_Handler:
    Context Save
    '---------------------------------------------------------------------------
    If F_TMR2IF = 1 Then                ' Check if this is a timer2 interrupt?
        $ifdef _Synchronize1mS_
        F_Timer1mS = 1                  ' Set a Flag every 1mS
        $endif
        $ifdef _SynchronizeB1mS_
        F_SMMain1mS = 1                 ' Set a Flag every 1mS
        $endif
        F_TMR2IF = 0                    ' Clear the Timer2 interrupt flag for next time.
        '-----------------------------------------------------------------------        
        $if _defined(_Timer10mS_) Or _defined(_Timer1S_)
        Inc Timer10mS
        If Timer10mS = 10 Then
            Timer10mS = 0           ' 100Hz Timer
            $ifdef _Synchronize10mS_
            F_Timer10mS = 1
            $endif
            $ifdef _Timer1S_
            Inc Timer500mS
            If Timer500mS = 50 Then
                Timer500mS = 0
                Toggle F_Timer500mS    ' 1 Hz Timer, to toggle some leds.
            EndIf 
            $endif
            ' Other Timers?
            ' Your code...
        EndIf
        $endif
        '-----------------------------------------------------------------------
        $ifdef _SMVDelay_
        ' Delay 1mS for the States.
        If F_SMVDelay = 1 Then           ' The VDelay is started.
            Dec SMDelayCounter          ' Decrements the SMDelayCounter every 1mS.
            If SMDelayCounter = 0 Then  ' Check if delay counter reaches 0.
                F_SMVDelay = 0           ' Delay END, clear the Vdelay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay1_
        ' Count every 1mS.
        If F_Delay1 = 1 Then            ' The Delay is started.
            Dec Delay1Counter           ' Decrements the DelayCounter every 1mS.
            If Delay1Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay1 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay2_
        ' Count every 1mS.
        If F_Delay2 = 1 Then            ' The Delay is started.
            Dec Delay2Counter           ' Decrements the DelayCounter every 1mS.
            If Delay2Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay2 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay3_
        ' Count every 1mS.
        If F_Delay3 = 1 Then            ' The Delay is started.
            Dec Delay3Counter           ' Decrements the DelayCounter every 1mS.
            If Delay3Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay3 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
    EndIf    
'-------------------------------------------------------------------------------
' Here the another user interrupt handler code....
' .......
' .......
' .......
'-------------------------------------------------------------------------------
END_INT:
'-------------------------------------------------------------------------------
    Context Restore                     ' Exit the interrupt handler and restore variables
    Declare Reminders = On
'*******************************************************************************
'*******************************************************************************
'* Name    : EEPROM Data                                                       *
'* Purpose : Write some strings in the EEPROM memory                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
E2p_AddressString1 EData "Testing the STATES MACHINE SMT03B scheduler",0

E2p_AddressString2 EData "using the Amicus18 Board,",0

E2p_AddressString3 EData "by Alberto Freixanet.",0
'******************************************************************************* 
STM_START:
'*******************************************************************************
' PLACE to insert the library files:
'*******************************************************************************
'* Name    : HRsout_K40.Inc                                                    *
'* Purpose : HRSout1,2,3,4,5 command for 1 or 2 stop bits                      *
'* Notes   :                                                                   *
'*******************************************************************************
    $define _DisableAllinterrupt_
'    $define _Disable2StopBits_
    Include "D:\MyIncFiles\HRsout_K40.inc"
'*******************************************************************************
'* Name    : ORG_SyncBlock.Inc                                                 *
'* Purpose : Generate an ORG command syncronized with the Erase Blocks         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : For Cdata Tables                                                  *
'******************************************************************************* 
    Include "D:\MyIncFiles\ORG_SyncBlock_K20.inc"
' Syntax: ORG_EBlock(pAddress)  
'===============================================================================
'===============================================================================
'###MAIN CODE###################################################################
STMAIN:
'*******************************************************************************
'* Name    : Init some variables                                               *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    WDTCON.0 = 0            ' Disable the Watchdog
    INTCON = 0              ' Disable All interrupts
    TBLPTRU = 0
    INTCON2Bits_RBPU = 1    ' Disable internal PullUp
    WPUB = 0                ' Pullups disabled in PORTB
    T0CON = 0

' Init the PORTS
'    ANSEL = 0
'    ANSELH = 0
'    CM1CON0 = 0
'    CM2CON0 = 0
    PORTA = 0               ' Clear all ports
    LATA = 0
    PORTB = 0
    LATB = 0    
    PORTC = 0
    LATC = 0
    Input PORTC.7
    Output PORTC.6
'*******************************************************************************
'* Name    :                                                                   *
'* Purpose : Initialize some variables of the States Machine                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    SM_UserFlags = 0
'-------------------------------------------------------------------------------
    ' Init the Timer2 for interrupts.
    InitStateMachine()

'###############################################################################
'#### STATE MACHINE STARTS #####################################################
' The Main code Start Here:
StateMachineInit:
'*******************************************************************************
'* Name    : NextState(0)                                                      *
'* Purpose : Initialize the State Machine.                                     *
'* Notes   : Start the first state.                                            *
'*******************************************************************************
    NextState(0)
'*******************************************************************************
'* Name    : StateMachineStart                                                  *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   : The ReturnSM() goes Here:                                         *
'*******************************************************************************
StateMachineStart:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : USER Functions                                                    *
'* Purpose : Write some Timing functions                                       *
'* Notes   : Using Timing flags only                                           *
'*******************************************************************************
' RUN Timer function: 
    $ifdef _Synchronize1mS_
    If F_Timer1mS = 1 Then
        F_Timer1mS = 0
        ' Your Code...
    EndIf
    $endif
'-------------------------------------------------------------------------------
    $ifdef _Synchronize10mS_
    If F_Timer10mS = 1 Then
        F_Timer10mS = 0
        ' Your Code...
    EndIf
    $endif
'-------------------------------------------------------------------------------
' RUN User Function1: Toggle the LED5 every 1/2 second.
    If F_UserFunction1 = 1 Then
        LED5 = F_Timer500mS
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function2: Clear LED4 after a delay2.
    If F_UserFunction2 = 1 Then
        If F_Delay2 = 0 Then
            LED4 = 0
            F_UserFunction2 = 0
        EndIf
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function3: Toggle the LED6/LED7 every 1/2 second.
    If F_UserFunction3 = 1 Then
        Output LED6_7
        LED6_7 = F_Timer500mS
    EndIf
'-------------------------------------------------------------------------------
   
'*******************************************************************************
'* Name    : States Machine Scheduler                                                          
'* Purpose :                    
'* Notes   :                                             
'===============================================================================
'  Running the States Machine2 in BackGround.
$ifdef _StatesMachine2_
    If State2Index > 0 Then
        GoTo StateMachine2Start 
    EndIf
$endif
' Return from States Machine2
ReturnStateMachine2:
'===============================================================================
    ' Running the Module Delay. The F_SMVDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SMVDelay_
    If F_SMVDelay = 1 Then
        GoTo StateMachineStart  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
    '===========================================================================
    ' Update the LABELS when you add a new States Machine Module.
    BranchL StateIndex,[STATE00,STATE01,STATE02,STATE03,STATE04,STATE05,STATE06,_
                        STATE07,STATE08,STATE09,STATE10,STATE11,STATE12,STATE13,_
                        STATE14,STATE15,STATE16,STATE17]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex is OUT of RANGE.
    $ifdef _SMVDelay_
    F_SMVDelay = 0
    $endif
    $ifdef _EnableTerminal_
        '$ifdef _DebugStates_
        _HRSOut "STATE OUT OF RANGE: ", Dec StateIndex,CR,LF
        DelayMS 1000
        '$endif
    $endif
    '---------------------------------------------------------------------------
    ' ERROR in States Machine Variable Range. Reset the States Machine. 
    GoTo StateMachineInit  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################
'*******************************************************************************
'* Name    : STATE00                                                          
'* Purpose : Initialize the project in the terminal window                     
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : Start the first state.                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE00:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
   
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    NextState2(0)       ' Stop running the States Machine2 in Background.

    HRSLStrg(TXT0,1)   ' "STATES MACHINE"
    HRSLStrg(TXT1,1)   ' "By A. Freixanet"
'-------------------------------------------------------------------------------
    IncState() 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE01                                                          
'* Purpose : Read the WDT config in memory map.                               
'* Input   : None                                                             
'* Output  : None                                                            
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim WDTdata As SMLVSByte1

' Define the Symbols used:
    Symbol _Config2h = $300003      ' Address in ROM of the WDT config, see the datasheet
'===============================================================================
STATE01:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT3,1)        ' "CONFIG FUSES: "
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT2,1)        ' Read the WDT config in memory map.

' Read the WDT config in memory map.
    EECON1 = %11000000              ' Access Configuration registers
    TBLPTRL = _Config2h & 255
    TBLPTRH = (_Config2h >> 8) & 255
    TBLPTRU = (_Config2h >> 16) & 255
    Tblrd*                          ' Read one memory position.  
    WDTdata = TABLAT                ' Copy the TABLAT SFR immediatly because it is cleared out of this routine??
    EECON1 = 0                      ' Disable Access the Configuration registers
    TBLPTRU = 0                     ' The HRSOut command of the compiler does not clear the "TBLPTRU = 0", then take care of that.
    '--------------------------------------------------------------------------- 
    $if (_device = _18F23K20) Or (_device = _18F24K20) Or (_device = _18F25K20) Or (_device = _18F26K20) Or (_device = _18F43K20) Or (_device = _18F44K20) Or (_device = _18F45K20) Or (_device = _18F46K20)
    WDTdata = WDTdata & 1
    If WDTdata = 1 Then
        HRSLStrg(TXT4,0)        ' "WDT enabled in hardware; SWDTEN bit disabled."
    Else
        HRSLStrg(TXT5,0)        ' "WDT controlled by the SWDTEN bit."
    EndIf
    $else
        $error "ERROR PIC!"
    $endif
    HRSOut CR
    '---------------------------------------------------------------------------
' Config Fuses:   BOREN = On        ' Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    RCONBits_SBOREN = 1
    If RCONBits_SBOREN = 1 Then
        HRSLStrg(TXT6,1)            ' "Brown-out Reset enabled!"
    Else
        HRSLStrg(TXT7,1)            ' "Brown-out Reset disabled!"
    EndIf
    '---------------------------------------------------------------------------
' Check the SWDTEN Bit.
    HRSLStrg(TXT8,1)                ' "Be carrefull the WDT is always active!"
    If WDTdata = 0 Then
        HRSLStrg(TXT9,0)            ' "After Reset the "

        If WDTCONBits_SWDTEN = 1 Then
            HRSLStrg(TXT10,1)       ' "SWDTEN Bit = 1 (error)"
        Else
            HRSLStrg(TXT11,1)       ' "SWDTEN Bit = 0 (good, by code)"
        EndIf
        WDTCONBits_SWDTEN = 1       ' Enable the Watchdog
        If WDTCONBits_SWDTEN = 1 Then
            HRSLStrg(TXT12,1)       ' "Now the SWDTEN Bit is set => Watchdog Enabled."
        Else
            HRSLStrg(TXT13,1)       ' "Now the SWDTEN Bit is Cleared => Watchdog Disabled."
        EndIf
    EndIf
    '---------------------------------------------------------------------------
    IncState() 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT14,1)    ' "WDT already checked!"
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE02                                                           *
'* Purpose : Read the PIC Part Number                                          *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'===============================================================================
' Define the Global variables used in this state:
    Dim PICPartNumber As Word
    Dim PICRevision As Word

' Define the Local variables used in this state:
    Dim DataWord As SMLVSWord1

' Define the Symbols used:
    Symbol ID_ADDRESS = $3FFFFE     ' Write the ID address. Location of (DEVID1) in memory map, see the datasheet
'===============================================================================
STATE02:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT15,1)    ' "Read the PIC ID from Config fuse."
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

' Read the PIC ID from Config fuse.
    EECON1 = %11000000              ' Access Configuration registers    
    TBLPTRL = ID_ADDRESS & 255
    TBLPTRH = (ID_ADDRESS >> 8) & 255
    TBLPTRU = (ID_ADDRESS >> 16) & 255
    Tblrd*+                         ' perform table read with post-increment
    DataWord.LowByte = TABLAT
    Tblrd*+                         ' perform table read with post-increment
    DataWord.HighByte = TABLAT        
    TBLPTRU = 0                     ' Cleared for security
    EECON1 = 0                      ' Disable Access the Configuration registers
    '---------------------------------------------------------------------------
    ' Calculate the PIC Part Number & revision
    PICPartNumber = DataWord >> 5
    PICRevision = DataWord.LowByte & 31
    '---------------------------------------------------------------------------
    HRSLStrg(TXT16,0)           ' "Device = "
    Select PICPartNumber
        Case 263
            HRSLStrg(TXT17,0)   ' "PIC18F23K20"
        Case 261
            HRSLStrg(TXT18,0)   ' "PIC18F24K20"
        Case 259
            HRSLStrg(TXT19,0)   ' "PIC18F25K20"
        Case 257
            HRSLStrg(TXT20,0)   ' "PIC18F26K20"
        Case 262
            HRSLStrg(TXT21,0)   ' "PIC18F43K20"
        Case 260
            HRSLStrg(TXT22,0)   ' "PIC18F44K20"
        Case 258
            HRSLStrg(TXT23,0)   ' "PIC18F45K20"
        Case 256
            HRSLStrg(TXT24,0)   ' "PIC18F46K20"
    EndSelect
    HRSOut CR
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT25,1)       ' "PIC PartNumber already checked!"
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE03                                                            
'* Purpose : Print the characterics of the PIC                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                    
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE03:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT43,1)    ' "Read the PIC informations."
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT26,AllChars,0) : HRSOut Dec _xtal : HRSLStrg(TXT27,0) ' "FOSC: ", Dec _xtal," Mhz"
    $ifdef _InternalOSC_
    HRSLStrg(TXT28,1)       ' " Internal Oscillator "
    $else
    HRSLStrg(TXT29,1)       ' " Xtal Oscillator "
    $endif

    HRSLStrg(TXT30,AllChars,0) : HRSOut Dec PICPartNumber : HRSLStrg(TXT31,AllChars,0) : HRSOut Hex4 PICPartNumber ' ", Revision: ", Dec PICPartNumber, " / $", Hex2 PICPartNumber,CR,LF
    HRSLStrg(TXT32,AllChars,0) : HRSOut Dec3 PICRevision : HRSLStrg(TXT31,AllChars,0) : HRSOut Hex4 PICRevision : HRSOut CR  ' ", Revision: ", Dec PICRevision, " / $", Hex2 PICRevision,CR,LF
    HRSLStrg(TXT33,AllChars,0) : HRSOut Dec _block : HRSLStrg(TXT34,1)
    HRSLStrg(TXT35,AllChars,0) : HRSOut Dec ERASE_FLASH_BLOCKSIZE : HRSLStrg(TXT34,1)
    HRSLStrg(TXT36,AllChars,0) : HRSOut Dec _eeprom : HRSLStrg(TXT34,1)
    HRSLStrg(TXT37,AllChars,0) : HRSOut Dec _code : HRSLStrg(TXT34,1)
    HRSLStrg(TXT38,AllChars,0) : HRSOut Dec _ram : HRSLStrg(TXT34,1)
    HRSLStrg(TXT39,AllChars,0) : HRSOut Dec _bankAend,CR
    HRSLStrg(TXT40,AllChars,0) : HRSOut Dec _rambanks,CR
    HRSLStrg(TXT41,AllChars,0) : HRSOut Dec _uart,CR
    HRSLStrg(TXT42,AllChars,0) : HRSOut Dec _HSerialBaud_,CR
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT44,1)       ' "PIC checked!"
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE04                                                          
'* Purpose : READING THE ISER ID LOCS                                          
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim Loop As SMLVSByte1

' Define the Symbols used :
    Symbol _ID_LOCATION = $200000   ' Write the IDLOCS address. Eight memory locations (200000h-200007h) are designated, see the datasheet
'===============================================================================
STATE04:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT45,1)       ' "Read the USER ID LOCS."
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT46,0)               ' Reading the PIC ID: 

    EECON1 = %11000000              ' Access Configuration registers
    TBLPTRL = _ID_LOCATION & $0000FF
    TBLPTRH = (_ID_LOCATION >> 8) & 255
    TBLPTRU = (_ID_LOCATION >> 16) & 255
    For Loop = 0 To 7               ' Start the loop
        Tblrd*+                     ' Read one memory position.
        HRSOut TABLAT
    Next  
    EECON1 = 0                      ' Disable read the Configuration registers
    TBLPTRU = 0 ' The HRSOut command of the compiler does not clear the "TBLPTRU = 0", then take care of that.
                ' The HRSOut command can crash if the TBLPTRU SFR is not cleared.
    HRSOut CR,LF
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT47,1)       ' ID LOCS checked.
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE05                                                           
'* Purpose : Send a String To the terminal read from the data eeprom memory.   
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:
    $if _eeprom > 256
    Dim EepAddress As Word System
    $else
    Dim EepAddress As Byte System    
    $endif
' Define the Local variables used in this state:

' Define the Symbols used :

'===============================================================================
STATE05:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT48,1)   ' "START READ EEPROM Strings:"
    '##-END INIT-###############################################################
    StateInitEnd()    
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ' Send 1st String.
    EepAddress = E2p_AddressString1
    GoSub ReadEEPString_Sub
    ' Send 2nd String.
    EepAddress = E2p_AddressString2
    GoSub ReadEEPString_Sub
    ' Send 3rd String.
    EepAddress = E2p_AddressString3
    GoSub ReadEEPString_Sub
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)     ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSLStrg(TXT49,1)   ' "END READ EEPROM Strings:" 
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd() 
'===============================================================================
    ReturnSM() 
'===============================================================================
'* Name    : ReadEEPString_Sub                                                
'* Called From: STATE05_MAIN                                                   
'* Purpose : Read a String written in the eeprom memory.                       
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this subroutine:

' Define the Global variables used in this subroutine:
    Dim E2PLoop As SMLVSByte1
    Dim E2PData As SMLVSByte2
    Dim E2PCounter As SMLVSByte3
' Define the Symbols used :

'===============================================================================
' Read a string written in the eeprom memory.
ReadEEPString_Sub:
    TBLPTRU = 0
    E2PLoop = 0
    E2PCounter = 0
    While 1 = 1     ' This infinite can be resolved quickly, then it is allowed.
        #ifdef WatchDog_Req
        Clrwdt
        #endif
        E2PData = ERead EepAddress + E2PLoop
        If E2PData = 0 Then          ' Check  if final of the string.
            HRSOut CR,LF
            Return 
        EndIf
        Inc E2PCounter
        If E2PCounter > 100 Then     ' Check maximun characters = 100 in a line.
            Return     
        Else
            HRSOut E2PData
        EndIf
        Inc E2PLoop
    Wend  
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE06                                                           
'* Purpose : Send some strings to the Terminal                                 
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE06:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT50,1)    ' "Strings read from the ROM memory." 
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT51,1)   ' "Testing the Amicus18 Board."
    HRSLStrg(TXT54,1)   ' "Using 8 push buttons and 8 LEDs.
    HRSLStrg(TXT56,1)   ' "LED8 & LED9 for other Tests"
    '---------------------------------------------------------------------------
    IncState()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StartFunction3()
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE07  (SM_ButtonsOff)                                                       
'* Purpose : Waiting until all Buttons depressed (OFF).                        
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : KEY NO AutoRepeat.        
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim Var1KEY As SMLVSByte1
' Define the Symbols used:

'===============================================================================
STATE07:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT52,1)           ' "Waiting All Buttons depressed!"
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ANSEL = 0                               ' PORTA digital
    ANSELH = 0                              ' PORTB digital
    TRISA = TRISA & %00001111               ' Leds outputs
    TRISC = TRISC & %11110000               ' Leds outputs 

    ' Waiting All KEYs OFF. Var1KEY = 0 => NO KEY pressed. 
    Var1KEY = InkeyX(80)                    ' Read the Keypad with 80uS delay for filtering.
    If Var1KEY = 0 Then                     ' When the Keys are depressed the output value is 0.
        NextStateDelay(30,SM_ReadKeypad)    ' Start a MDelay (30mS) before to read the Keypad.
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)    ' 30 mS => sample time of the KEYPAD.
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE08 (SM_ReadKeypad)
'* Purpose : Read all Buttons with InkeyX(50)
'* Input   : None
'* Output  : None                                                             
'* Notes   : The InkeyX(50) returns a "0" if NO Key pressed.                                                                 
'===============================================================================
' Define the Global variables used in this state:
    Dim KEYnOld As Byte
    Dim KEYCounter As Byte
' Define the Local variables used in this state:
    Dim KEYn As SMLVSByte1
    Dim KEY_Result As SMLVSByte2
' Define the Symbols used:

'===============================================================================
STATE08:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################
    HRSLStrg(TXT58,1)               ' "Waiting a KEY pressed!"
    KEYnOld = 0                     ' Initialize parameters for debouncing.
    KEYCounter = 0
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    KEYn = InkeyX(50)               ' Read the Keypad with 50uS delay for filtering.

    If KEYn > 0 Then                ' If a KEY pressed then decode the KEY.
        If KEYnOld = KEYn Then      ' Some debounce system
            Inc KEYCounter
            If KEYCounter = 5 Then  ' 5 + 1 readings necessary. (30mS X 6 = 180mS)
                KEYCounter = 0
                                  'KEYn = 0  1   2   3   4   5   6   7   8   9  10  11  12         
                KEY_Result = LookUp KEYn,[0,"1","2","3","4","5","6","7","8","9","*","0","#"]
                Select KEY_Result
                    Case "0"
                        NextState(SM_Set_LED0)
                    Case "1"
                        NextState(SM_Clear_LED0)
                    Case "2"
                        NextState(SM_Set_LED1)
                    Case "3"
                        NextState(SM_Clear_LED1)
                    Case "4"
                        NextState(SM_Set_LED2)
                    Case "5"
                        NextState(SM_Clear_LED2)
                    Case "6"
                        NextState(SM_Set_LED3)
                    Case "7"
                        NextState(SM_Clear_LED3)
                    Case "8"
                        HRSOut CR,LF
                        HRSLStrg(TXT77,1)           ' "KEY 8 pressed!"
                        StartFunction3()            ' Start the new Function3
                        NextState(SM_ButtonsOff)
                    Case "9"
                        HRSOut CR,LF
                        HRSLStrg(TXT79,1)           ' "KEY 9 pressed!"
                        StopFunction3()             ' Stop the new Function3
                        NextState(SM_ButtonsOff)
                    Case "*"
                        HRSOut CR,LF
                        HRSLStrg(TXT82,1)           ' "KEY * pressed!"
                        NextState(SM_ButtonsOff)
                    Case "#"
                        NextState(SM_Toggle_LED5)   ' "START Toggle LED5", "STOP Toggle LED5"
                    Case Else
                        NextState(SM_ButtonsOff)    ' Come back reading buttons            
                EndSelect
            EndIf
        Else
            KEYCounter = 0  ' If another KEY is pressed then clear the counter.
        EndIf
        KEYnOld = KEYn
    Else
        KEYCounter = 0      ' KEY depressed Then Clear the Counter.
    EndIf        

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)    ' Adjust some sample time 30mS to debounce the KEYPAD.
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StartBeep()    ' Generate a pulse (Beep) of 0,250 second  for every Button pressed.
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE09  (SM_Set_LED0)                                                       
'* Purpose : Set LED0                                                
'* Input   : None                                                          
'* Output  : None                                                            
'* Notes   :                                                         
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE09:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT59,0)       ' "KEY0 pressed!"
    Set LED0
    HRSLStrg(TXT60,0)       ' ", Set"
    HRSLStrg(TXT62,1)       ' " LED0"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)    ' Goto read the Keypad 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)             ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE10  (SM_Clear_LED0)                                                         
'* Purpose : Clear LED0                                                 
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   :                                                                 
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE10:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd() 
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT63,0)           ' "KEY1 pressed!"
    Clear LED0
    HRSLStrg(TXT61,0)           ' ", Clear"
    HRSLStrg(TXT62,1)           ' " LED0"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)    ' Goto read the Keypad

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE11  (SM_Set_LED1)                                                        
'* Purpose : Set LED1                                                
'* Input   : None                                                             
'* Output  : None                                                             
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE11:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd() 
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT65,0)           ' "KEY2 pressed!"
    Set LED1
    HRSLStrg(TXT60,0)           ' ", Set"
    HRSLStrg(TXT64,1)           ' " LED1"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)  ' Goto read the Keypad

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE12  (SM_Clear_LED1)                                                         
'* Purpose : Clear LED1                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
 
'===============================================================================
STATE12:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT67,0)       ' "KEY3 pressed!"
    Clear LED1
    HRSLStrg(TXT61,0)       ' ", Clear"
    HRSLStrg(TXT64,1)       ' " LED1"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)  ' Goto read the Keypad

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE13  (SM_Set_LED2)                                                        
'* Purpose : Set LED2                                                
'* Input   : None                                                             
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE13:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()    
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT69,0)           ' "KEY4 pressed!"
    Set LED2
    HRSLStrg(TXT60,0)           ' ", Set"
    HRSLStrg(TXT66,1)           ' " LED2"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)  ' Goto read the Keypad

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE14  (SM_Clear_LED2)                                                         
'* Purpose : Clear LED2                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE14:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT71,0)           ' "KEY5 pressed!"
    Clear LED2
    HRSLStrg(TXT61,0)           ' ", Clear"
    HRSLStrg(TXT66,1)           ' " LED2"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)  ' Goto read the Keypad         

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE15  (SM_Set_LED3)                                                           
'* Purpose : Set LED3                                                 
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE15:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT73,0)           ' "KEY6 pressed!"
    Set LED3
    HRSLStrg(TXT60,0)           ' ", Set"
    HRSLStrg(TXT68,1)           ' " LED3"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)  ' Goto read the Keypad         

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE16  (SM_Clear_LED3)                                                          
'* Purpose : Clear LED3                                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                    
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE16:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT75,0)           ' "KEY7 pressed!"
    Clear LED3
    HRSLStrg(TXT61,0)           ' ", Clear"
    HRSLStrg(TXT68,1)           ' " LED3"
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)  ' Goto read the Keypad 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE17 (SM_Toggle_LED5)                                                        
'* Purpose : Toggle LED5 at 0,5 Hz                                                     
'* Input   : None                                                            
'* Output  : None                                                            
'* Notes   : StartFunction1(), StopFunction1()                                                               
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE17:
'===============================================================================
    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::MAIN CODE:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT81,1)           ' "KEY ON/C pressed!"
    If F_UserFunction1 = 0 Then
        StartFunction1()
        HRSLStrg(TXT86,1)       ' "START Toggle LED5"
    Else
        StopFunction1()
        HRSLStrg(TXT87,1)       ' STOP Toggle LED5
    EndIf
    '---------------------------------------------------------------------------
    NextState(SM_ButtonsOff)  ' Goto read the Keypad 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===EXIT SECTION=================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE18                                                           *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE18:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

          
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE19                                                           *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE19:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

          
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************


'*******************************************************************************
'###############################################################################
'#### STATE MACHINE2 STARTS ####################################################
$ifdef _StatesMachine2_
' The Main code Start Here:
'*******************************************************************************
'* Name    : StateMachine2Start                                                *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   :                                                                   *
'*******************************************************************************
StateMachine2Start:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : States Machine2 Scheduler                                                          
'* Purpose : Running the code of all modules.                   
'* Notes   : Do not forget update the State Label.                                            
'===============================================================================
    ' Running the Module2 Virtual Delay. The F_SM2VDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SM2VDelay_
    If F_SM2VDelay = 1 Then
        GoTo ReturnStateMachine2  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
'===============================================================================
    ' Update the LABELS when you add a new States Machine Module.
    BranchL State2Index,[STATE100,STATE101,STATE102]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex2 is OUT of RANGE.
    $ifdef _SM2VDelay_
    F_SM2VDelay = 0     ' Clear any VDelay2
    $endif
    $ifdef _EnableTerminal_
    _HRSOut "STATE MACHINE2 OUT OF RANGE: ", Dec State2Index,13,10
    DelayMS 1000
    $endif
    NextState2(0)
    ' ERROR in States Machine2 Variable Range. Reset the States Machine2. 
    GoTo ReturnStateMachine2  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################
'*******************************************************************************
'* Name    : STATE100  []       
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : A not used Label is needed For the Scheduler.                                                            
'===============================================================================
STATE100:   ' [SM2_Init]
    ' Nothing to do.
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE101 []        
'* Purpose : Print a message to the LCD in Background                                                      
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : Module in Test                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE101:
'===============================================================================
    StateInit2()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInit2End()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

          
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    SM2StartDelayMS(0)
'===============================================================================
    StateOut2(0)        ' Disable the Time Counter (NO code).
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE102 []        
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : Module in Test                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE102:
'===============================================================================
    StateInit2()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInit2End()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

           
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    SM2StartDelayMS(0)
'===============================================================================
    StateOut2(0)        ' Disable the Time Counter (NO code).
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************


'*******************************************************************************
'*******************************************************************************
' End of States Machine2
$endif  
'*******************************************************************************
'###############################################################################
'###############################################################################
'*** SUBROUTINES ***************************************************************
'*******************************************************************************
' Subroutines of the project.
''*******************************************************************************
''* Name    : ReadEEPString_Sub                                                 *
''* Purpose : Read a String written in the eeprom memory.                       *
''* Input   : None                                                              *
''* Output  : None                                                              *
''* Notes   : Use Bytes System only for variables                               *
''*******************************************************************************
' Define the Global variables used in this state:

' Define the Symbols used:

'===============================================================================


'*******************************************************************************
'* Name    :                                                *
'* Purpose : Read the state all buttons of the Board                           *
'*         : To the terminal.                                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
' Define the Global variables used in this state:

' Define the Symbols used:

'===============================================================================

'    Return
'*******************************************************************************
'* Name    :                                         *
'* Purpose :                        *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************  
' Define the Global variables used in this state:

' Define the Symbols used:



'===============================================================================

'===============================================================================



'*******************************************************************************
'* Name    : STM_Strings00.Inc                                                 *
'* Purpose : CData Table for Strings or Datas                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Write the Tables at top of memory syncronized with Erase Block    *
'*         : The Cdata table could have 1600 Bytyes                            *
'*         : Table of Strings of the program                                   *
'*******************************************************************************
'    ORG_EBlock(_MAXMEM - 1600)
    Include "D:\MyIncFiles\STM_Strings02.Inc"
'*******************************************************************************
' Write some static data to the ID Locations.
' STM3BV10
Asm
__IDLOCS   __IDLOC0,0x53
__IDLOCS   __IDLOC1,0x54
__IDLOCS   __IDLOC2,0x4D
__IDLOCS   __IDLOC3,0x33
__IDLOCS   __IDLOC4,0x42
__IDLOCS   __IDLOC5,0x56
__IDLOCS   __IDLOC6,0x31
__IDLOCS   __IDLOC7,0x30
EndAsm
'*******************************************************************************
'*** END OF FILE ***************************************************************
'*******************************************************************************

                
