'****************************************************************
'*  Name    : STM05D.bas                                        *
'*  Project : Testing the State Machine Template                *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) February 2017 [A. Freixanet 2017]   *
'*          : All Rights Reserved                               *
'*  Date    : 24/03/2017                                        *
'*  Version : 1.0                                               *
'*  Notes   : Using the AMICUS18 Development Board              *
'*          : CPU : PIC18F25K20 with Xtal 16Mhz, with 4xPLL     *
'*            CoolTerm Terminal is Used for testing             *
'* Powered by PROTON DEVELOPMENT SUITE COMPILER V3.5.9.3        *
'*          Testing the DS1307 clock calendar                   *
'*          BEST DESIGN                                         *
'*          Configuration of Date/Time by Buttons               *
'* This code is prepared to download by the AGV BootloaderV4.1  *
'****************************************************************
'
'===============================================================================
' This source code is free software and provided 'as is', any express or implied 
' warranties are disclaimed. you can redistribute it and/or modify.
' The author is not responsible of the use of this software.
' This program is distributed in the hope that it will be useful, but WITHOUT 
' ANY WARRANTY. However, a mention of the author and compiler would be appreciated.
'*******************************************************************************
' Este cdigo fuente es un software libre, puede redistribuirlo y/o modificarlo.
' El autor no se hace responsable del uso de este software.
' Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.
'*******************************************************************************
' Ce code source est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' L'auteur n'est pas responsable de l'utilisation de ce logiciel.
' Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE.
' Cependant mentionner l'auteur et le compileur serait trs aprci.
'*==============================================================================
' Testing the CODE by Proteus
    $define _ProteusDebug_
'===============================================================================
' Choose the Bootloader you are using for the Amicus18 Board (real hardware).
' CHOOSE ONLY ONE.
$ifndef _ProteusDebug_

'    $define _AmicusBootloader_
    $define _LSM_AGV_BootloaderV41_

$endif
'===============================================================================

    Device = 18F25K20

    $ifdef _ProteusDebug_
    ' Settings CPU Proteus at 4Mhz (with settings fuses)
    Declare Xtal = 16
    $else
    ' Settings CPU Amicus18 Board at 16Mhz (with settings fuses)
    Declare Xtal = 64
    $endif
'*******************************************************************************
'* Name    : Compiler Declare                                                  *
'* Purpose : Configuration of the compiler                                     *
'* Notes   :                                                                   *
'******************************************************************************* 
    $if _defined(_LSM_AGV_BootloaderV41_) And _defined(_AmicusBootloader_)
        $error "ONLY CHOOSE ONE BOOTLOADER"
    $endif

    ' More security using the Bootloader in the Low Side of ROM memory (only for real piece).
    $ifdef _LSM_AGV_BootloaderV41_
        Declare PROTON_START_ADDRESS = 2048
    $endif
    '---------------------------------------------------------------------------
    Declare Eeprom_Address = $F00000
    Declare Optimiser_Level = 2
    Declare Dead_Code_Remove = On
    Declare Create_Coff = On
    Declare Watchdog = On
'    Declare Float_Display_Type = Fast
'    Declare Float_Rounding = Off
    Declare Bootloader = Off
'    Declare Show_System_Variables = On
    Declare MemWrite_Int_Control = 1
    $if 65537 < _code
    Declare Access_Upper_64K = On
    $endif
'    Declare Keypad_Port PORTB
'-------------------------------------------------------------------------------
    $ifdef _ProteusDebug_
    $define _PinsTest_
    $endif
'===============================================================================
$ifdef _ProteusDebug_
'-------------------------------------------------------------------------------
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	 ;Oscillator Switchover mode disabled
    PWRT = On	  ;PWRT enabled
    BOREN = On	 ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	  ;VBOR set to 2.2 V nominal
    WDTEN = OFF	    ;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	    ;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	     ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	  ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = OFF	;Boot block (000000-0007FFh) not code-protected
    CPD = OFF	;Data EEPROM not code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
'-------------------------------------------------------------------------------
$else
'-------------------------------------------------------------------------------
$ifdef _AmicusBootloader_
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	    ;Fail-Safe Clock Monitor disabled
    IESO = OFF	 ;Oscillator Switchover mode disabled
    PWRT = On	  ;PWRT enabled
    BOREN = On	 ;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	  ;VBOR set to 2.2 V nominal
    WDTEN = OFF	    ;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	    ;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	     ;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	    ;Stack full/underflow will cause Reset
    LVP = OFF	  ;Single-Supply ICSP disabled
    XINST = OFF	    ;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	    ;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = OFF	;Boot block (000000-0007FFh) not code-protected
    CPD = OFF	;Data EEPROM not code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = OFF	;Boot Block (000000-0007FFh) not write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = OFF	;Boot Block (000000-0007FFh) not protected from table reads executed in other blocks
Config_End
$else
' Full Boot Block protected for the Low Side ROM Bootloader V4.1.
Config_Start
    FOSC = HSPLL	;HS oscillator, PLL enabled (Clock Frequency = 4 x FOSC1)
    FCMEN = OFF	;Fail-Safe Clock Monitor disabled
    IESO = OFF	;Oscillator Switchover mode disabled
    PWRT = On	;PWRT enabled
    BOREN = On	;Brown-out Reset enabled and controlled by software (SBOREN is enabled)
    BORV = 22	;VBOR set to 2.2 V nominal
    WDTEN = OFF	;WDT is controlled by SWDTEN bit of the WDTCON register
    WDTPS = 128	;1:128
    CCP2MX = PORTC	;CCP2 input/output is multiplexed with RC1
    PBADEN = On	    ;PORTB<4:0> pins are configured as analog input channels on Reset
    LPT1OSC = OFF	;Timer1 configured for higher power operation
    HFOFST = OFF	;The system clock is held off until the HFINTOSC is stable.
    MCLRE = On	;MCLR pin enabled; RE3 input pin disabled
    STVREN = On	;Stack full/underflow will cause Reset
    LVP = OFF	;Single-Supply ICSP disabled
    XINST = OFF	;Instruction set extension and Indexed Addressing mode disabled (Legacy mode)
    Debug = OFF	;Background debugger disabled, RB6 and RB7 configured as general purpose I/O pins
    Cp0 = OFF	;Block 0 (000800-001FFFh) not code-protected
    CP1 = OFF	;Block 1 (002000-003FFFh) not code-protected
    CP2 = OFF	;Block 2 (004000-005FFFh) not code-protected
    CP3 = OFF	;Block 3 (006000-007FFFh) not code-protected
    CPB = On	;Boot block (000000-0007FFh) code-protected
    CPD = On	;Data EEPROM code-protected
    WRT0 = OFF	;Block 0 (000800-001FFFh) not write-protected
    WRT1 = OFF	;Block 1 (002000-003FFFh) not write-protected
    WRT2 = OFF	;Block 2 (004000-005FFFh) not write-protected
    WRT3 = OFF	;Block 3 (006000-007FFFh) not write-protected
    WRTC = On	;Configuration registers (300000-3000FFh) write-protected
    WRTB = On	;Boot Block (000000-0007FFh) write-protected
    WRTD = OFF	;Data EEPROM not write-protected
    EBTR0 = OFF	;Block 0 (000800-001FFFh) not protected from table reads executed in other blocks
    EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from table reads executed in other blocks
    EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from table reads executed in other blocks
    EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from table reads executed in other blocks
    EBTRB = On	;Boot Block (000000-0007FFh) protected from table reads executed in other blocks
Config_End
$endif
'-------------------------------------------------------------------------------
$endif
'*******************************************************************************
'* Name    : LCD                                                               *
'* Purpose : Declare the LCD pins                                              *
'* Notes   : Configuration of the LCD for the AMicus18 Board.                  *
'******************************************************************************* 
    Declare LCD_DTPin = PORTB.4         ' LCD's Data lines (D4 to D7)
    Declare LCD_ENPin = PORTB.3         ' LCD's EN line
    Declare LCD_RSPin = PORTB.2         ' LCD's RS line
    Declare LCD_Interface = 4           ' 4-bit interface to LCD
    Declare LCD_Lines = 2               ' LCD contains 2 lines
    Declare LCD_DataUs = 50             ' Time to wait after print a data To LCD
    Declare LCD_CommandUs = 2000        ' Time to wait after print a command to LCD
    Declare LCD_Type = Alphanumeric     ' LCD type is alphanumeric
    Symbol __LCD_CharsLenght = 16       ' For the AMI18 LCD Shield: 16 Characters
'*******************************************************************************
'* Name    : Variables & Constants                                             *
'* Purpose : Declare the Variables or Constants                                *
'* Notes   : The local variables are declared for this State Machine file only *
'* Rules   : If the Variable is used once then get Local Variable.             *
'*         : If the Variable is used several times in a large loop in STM1     *
'*         : with STM2 or in others modules then get a Global Variable.        *
'******************************************************************************* 
' Definition of local Bytes for Main code only
$ifndef _SMLVBS_Block1_
    $define _SMLVBS_Block1_
    Dim SMLVSByte1 As Byte System     ' Local Variable System Byte1
    Dim SMLVSByte2 As Byte System     ' Local Variable System Byte2
    Dim SMLVSByte3 As Byte System     ' Local Variable System Byte3
    Dim SMLVSByte4 As Byte System     ' Local Variable System Byte4
$endif
' If you need more local Byte Variables, uncomment this block.
'$ifndef _SMLVBS_Block2_
'    $define _SMLVBS_Block2_
'    Dim SMLVSByte5 As Byte System     ' Local Variable System Byte1
'    Dim SMLVSByte6 As Byte System     ' Local Variable System Byte2
'    Dim SMLVSByte7 As Byte System     ' Local Variable System Byte3
'    Dim SMLVSByte8 As Byte System     ' Local Variable System Byte4
'$endif

' Definition of local Words For Main Code only
$ifndef _SMLVWS_Block1_
    $define _SMLVWS_Block1_
    Dim SMLVSWord1 As Word System     ' Local Variable System Word1
    Dim SMLVSWord2 As Word System     ' Local Variable System Word2
$endif
' If you need more local Word Variables, uncomment this block.
'$ifndef _SMLVWS_Block2_
'    $define _SMLVWS_Block2_
'    Dim SMLVSWord3 As Word System     ' Local Variable System Word1
'    Dim SMLVSWord4 As Word System     ' Local Variable System Word2
'$endif

' Definition of local DWords For Main Code only
'$ifndef _SMLVDWS_Block1_
'    $define _SMLVDWS_Block1_
'    Dim SMLVSDWord1 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord2 As DWord System     ' Local Variable System Word2
'$endif
' If you need more local Dword Variables, uncomment this block.
'$ifndef _SMLVDWS_Block2_
'    $define _SMLVDWS_Block2_
'    Dim SMLVSDWord3 As DWord System     ' Local Variable System Word1
'    Dim SMLVSDWord4 As DWord System     ' Local Variable System Word2
'$endif

' Definition of local bits
'$ifndef _LVSBitS_Block1_
'    $define _LVSBitS_Block1_
'    Dim LVSBitsA As Byte System     ' Local Variable System byte
'$endif
'-------------------------------------------------------------------------------
' Global Bits for the USER
    Dim SM_UserFunctionFlags As Byte System
    Dim F_UserFunction1 As SM_UserFunctionFlags.0 
    Dim F_UserFunction2 As SM_UserFunctionFlags.1
    Dim F_UserFunction3 As SM_UserFunctionFlags.2
    Dim F_UserFunction4 As SM_UserFunctionFlags.3
    Dim F_UserFunction5 As SM_UserFunctionFlags.4
    Dim F_UserFunction6 As SM_UserFunctionFlags.5        
    Dim F_UserFunction7 As SM_UserFunctionFlags.6
    Dim F_UserFunction8 As SM_UserFunctionFlags.7

'    Dim SM_UserFlags As Byte System

    Dim TimeOutGotoNextState As Byte System    

    ' Flags
    Dim SM_AllFlags As Byte System
    Dim F_DS1307_1S As SM_AllFlags.0
'-------------------------------------------------------------------------------
' Definition of the LEDS for Amicus18.
    Symbol LCD_Backlight = LATA.5
    Symbol LED1 = LATA.4
    Symbol LED2 = LATC.2
    Symbol Button1 = PORTA.0
    Symbol Button2 = PORTA.1
    Symbol Button3 = PORTA.2
    Symbol Button4 = PORTA.3            

' Definition of the Test pins.
    $ifdef _PinsTest_
    Symbol Test1 = LATC.0
    Symbol Test2 = LATC.1 
    $endif

'*******************************************************************************
'* Name    : Language                                                          *
'* Purpose : Define one language for this project                              *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : One language must be enabled                                      *
'*******************************************************************************            
    $define _English_
'    $define _Spanish_
'    $define _French_ 
'*******************************************************************************
'* Name    : Write the ARRAYs in BANK0 and upward                              *
'* Purpose : Declare manually a Dummy Array                                    *
'* Notes   : Using a Dummy Byte as reference                                   *
'******************************************************************************* 
    Dim MyDummyByte As Byte     ' This byte is to calculate the position of the Arrays

    ' After last compiling, verify the address (in asm file) of the variable "MyDummyByte" 
    ' and update the AddressofMyDummyByte value.
    $ifdef _ProteusDebug_
    $define AddressofMyDummyByte 61
    $else
    $define AddressofMyDummyByte 64    
    $endif

    $ifdef _bankAend
        $if AddressofMyDummyByte < _bankAend
            $define DummyArray_Lenght _bankAend - AddressofMyDummyByte + 1
            Dim DummyArray[DummyArray_Lenght] As Byte  
        $endif
    $else
        $error "The _bankAend parameter is absent from the .def file of the PDS!"
    $endif
'===============================================================================
'===============================================================================
' Bits definition of the PIC18F25K20.
'
    Include "D:\MyIncFiles\SYS_18FXXK20.inc"
'*******************************************************************************
'* Name    : State machine numbers                                             *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM_Init 0           ' STATE00
    $define SM_ProjectInfo 1    ' STATE01
    $define SM_CheckACK 2       ' STATE02
    $define SM_Enable1Hz 3      ' STATE04
    $define SM_Config 4         ' STATE03
    $define SM_ReadTimeDate 5   ' STATE05
    $define SM_Error_NACK 6     ' STATE06
    $define SM_AskForConfig 7   ' STATE07
    $define SM_ButtonsOFF 8     ' STATE08
    $define SM_ReadButtons 9    ' STATE09    
    $define SM_ButtonsOFF2 10   ' STATE10
    $define SM_GetWeek 11       ' STATE11
    $define SM_GetDay 12        ' STATE12
    $define SM_GetMonth 13      ' STATE13
    $define SM_GetYear 14       ' STATE14
    $define SM_GetHour 15       ' STATE15
    $define SM_GetMinute 16     ' STATE16
    
'*******************************************************************************
'* Name    : State machine2 numbers                                            *
'* Purpose : Define every State with a name (optional)                         *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
    $define SM2_Init 0          ' STATE100
    $define SM2_Function1 1     ' STATE101
    $define SM2_Function2 2     ' STATE102

'*******************************************************************************
'* Name    : Enable the Library Commands inside the STMachine00.Inc file       *
'* Notes   :                                                                   *
'*******************************************************************************
' Uncomment the followed line to insert the Keypad option.
'    $define _Disable_Pullups_
'    $define _4x4KEYPAD_
'    $define _4x3KEYPAD_
'    $define _4x2KEYPAD_
'-------------------------------------------------------------------------------
' Others States Machine libraries.
    $define _HRSE2PStrg_
'    $define _Manchester_
'    $define _MidPoint_
'    $define _MedianFilter_
'    $define _BubbleSort_
'    $define _GetParity_
'    $define _RotateBits_
'    $define _BinaryTo3BCD_
'    $define _BCD2ToBinary_
'    $define _WordTo5BCD_
'    $define _DwordArray_
'    $define _CountUntil_
'    $define _ArrayROL_
'    $define _ArrayROR_
'    $define _ArrayROLR_
'    $define _ArrayRORR_
'    $define _ArrayBit_
'    $define _CRC16_

'*******************************************************************************
'* Name    : HSerial                                                           *
'* Purpose : Declare the HSerial Communication for the STM Library             *
'* Notes   : Uncomment a line to declare a Terminal Baud Rate. (One only)      *
'******************************************************************************* 
' Uncomment a line to define a Terminal Baud Rate, and compile. (One only)
$ifdef _ProteusDebug_
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
'    $define _HSerialBaud_ 115200
$else
'    $define _HSerialBaud_ 9600
'    $define _HSerialBaud_ 19200   
'    $define _HSerialBaud_ 38400
'    $define _HSerialBaud_ 57600
    $define _HSerialBaud_ 115200
$endif
'===============================================================================
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial_Clear  = On         ' Clear overflow automatically
'    Declare Hserial_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial_Baud = 9600
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial_Baud = 115200
        Declare Hserial_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial_Clear = On      ' Enable Error clearing on received characters
    $endif
'-------------------------------------------------------------------------------
(*
'    $if _HSerialBaud_ = 9600
'    'Calculated Baudrate = 9598 @ Xtal 64MHz, Error = -0,02%
'    Declare Hserial2_RCSTA  = %10010000  ' Enable continuous receive 
'    Declare Hserial2_TXSTA  = %00100100  ' Enable transmit, BRGH = 1
'    Declare Hserial2_Clear  = On         ' Clear overflow automatically
'    Declare Hserial2_SPBRG  = $82        ' Baud Rate Generator Low Byte Value
'    SPBRGH    = $06                     ' Baud Rate Generator High Byte Value
'    BAUDCON.3 = 1                       ' Enable the 16 bit Baud Rate Generator  
'    $endif

    $if _HSerialBaud_ = 9600
        Declare Hserial2_Baud = 9600
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 19200
        Declare Hserial2_Baud = 19200        ' Set baud rate to 19200
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 38400
        Declare Hserial2_Baud = 38400        ' Set baud rate to 38400
        Declare Hserial2_RCSTA = %10010000   ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = %00100100   ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On          ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 57600
        Declare Hserial2_Baud = 57600    ' Set baud rate to 57600
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
    $if _HSerialBaud_ = 115200
        Declare Hserial2_Baud = 115200
        Declare Hserial2_RCSTA = 144     ' Enable serial port and continuous receive
        Declare Hserial2_TXSTA = 36      ' Enable transmit and asynchronous mode
        Declare Hserial2_Clear = On      ' Enable Error clearing on received characters
    $endif
*)
'-------------------------------------------------------------------------------
'===============================================================================
' Choose the HSRSout command for the STM Library. (One only)
    $define _HRSOut HRSOut
'    $define _HRSOut HRSOut1
'    $define _HRSOut HRSOut2
'    $define _HRSOut HRSOut3
'    $define _HRSOut HRSOut4
'    $define _HRSOut HRSOut5
'*******************************************************************************
'* Name    : State Machine Commands                                            *
'* Notes   : Uncomment the line to enable a STM Function                       *
'*******************************************************************************
' Uncomment the followed line to disable the terminal function to send strings
' for the STM Library only.
    $define _EnableTerminal_

' Uncomment the followed line to enable the ReturnSM function.
' Disabled = Default configuration.
'    $define _CheckReturnStateM_

' Uncomment the followed line to disable the Carriage Return before every state
' for the STM Library only. 
' Enabled = Default configuration.
    $define _DisableCRBeforeState_

' Uncomment the followed line to enable some Timers
' All Enabled = Default configuration.
    $define _Timer10mS_
    $define _Timer1S_

' Uncomment the followed line to Synchronize the Main code with Timer 1mS.
' All Disabled = Default configuration.
'    $define _Synchronize1mS_
    $define _SynchronizeB1mS_
'    $define _Synchronize10mS_

' Uncomment the followed line to enable some Delays
' Enabled = Default configuration.
    $define _SMVDelay_

' User Delay1. Disabled = Default configuration.
    $define _Delay1_    

' User Delay2. Disabled = Default configuration.
    $define _Delay2_     

' User Delay3. Disabled = Default configuration.
'    $define _Delay3_

' (For DEBUG) Uncomment the followed line to insert a state number in every module.
' Disabled = Default configuration.
'    $define _DebugStates_

' Uncomment the followed line to enable another States Machine2 in Background
' All Disabled = Default configuration.
    $define _StatesMachine2_
'    $define _SM2VDelay_
'    $define _TimeCounter_

'-------------------------------------------------------------------------------
    ' Library for the States Machine system.
    Include "D:\MyIncFiles\STMachine00.inc"
'*******************************************************************************
'=============================================================================== 
    GoTo STM_START
'*******************************************************************************
'* Name    : USER FUNCTION 1 (only Meta Macro, no Subroutine)                  *
'* Purpose : Toggle the LED5                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'*******************************************************************************  
    $define StartFunction1() F_UserFunction1 = 1

    $define StopFunction1() F_UserFunction1 = 0 : LED1 = 0   

'*******************************************************************************
'* Name    : USER FUNCTION 2 (only Meta Macro, no Subroutine)                  *
'* Purpose : Set the LED2 for 250 mS                                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'******************************************************************************* 
    $define StartBeep() '
    F_UserFunction2 = 1 '
    LED2 = 1            '
    StartUserDelay2(250)

'*******************************************************************************
'* Name    : USER FUNCTION 3 (Meta Macro And Subroutine)                       *
'* Purpose : Set a time out to read the Buttons                                *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Time Out for the Time/Date/Contrast Menus                         *
'******************************************************************************* 
$define StartTimeOut(pNewState,pDelay) '
    TimeOutGotoNextState = pNewState   '
    F_UserFunction3 = 1                '
    StartUserDelay1(pDelay*1000)

'-------------------------------------------------------------------------------
$define CheckTimeOut() GoSub CheckTimeOut_Sub

CheckTimeOut_Sub:
    If F_UserFunction3 = 1 Then
        If F_Delay1 = 0 Then
            StateIndex = TimeOutGotoNextState       
            F_UserFunction3 = 0
        EndIf
    EndIf
    Return
'-------------------------------------------------------------------------------
    $define DisableTimeOut() '
    F_UserFunction3 = 0      '
    F_Delay1 = 0

'*******************************************************************************
'* Name    : USER FUNCTION 4 (only Meta Macro, no Subroutine)                  *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Generate special Routines inside the State Machine Timing         *
'******************************************************************************* 

'===============================================================================
UserFunctionsExit:
'*******************************************************************************
'* Name    : High Interrupt_Handler                                            *
'* Purpose : Generate a 1mS interrupt                                          *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Using the Timer2 & PR2 it is more easy.                           *
'*******************************************************************************     
    On_Hardware_Interrupt GoTo Interrupt_Handler
'-------------------------------------------------------------------------------
'Interrupt Handler.
    Declare Reminders = OFF
Interrupt_Handler:
    Context Save
    '---------------------------------------------------------------------------
    If PIR1Bits_TMR2IF = 1 Then     ' Check if this is a timer2 interrupt?
        $ifdef _Synchronize1mS_
        F_Timer1mS = 1              ' Set a Flag every 1mS
        $endif
        $ifdef _SynchronizeB1mS_
        F_SMMain1mS = 1             ' Set a Flag every 1mS
        $endif
        PIR1Bits_TMR2IF = 0         ' Clear the Timer2 interrupt flag for next time.
        $ifdef _PinsTest_
        Toggle Test1
        $endif
        '-----------------------------------------------------------------------        
        $if _defined(_Timer10mS_) Or _defined(_Timer1S_)
        Inc Timer10mS
        If Timer10mS = 10 Then
            Timer10mS = 0           ' 100Hz Timer
            $ifdef _Synchronize10mS_
            F_Timer10mS = 1
            $endif
            $ifdef _Timer1S_
            Inc Timer500mS
            If Timer500mS = 50 Then
                Timer500mS = 0
                Toggle F_Timer500mS    ' 1 Hz Timer, to toggle some leds.
                If F_Timer500mS = 1 Then
                    F_Timer1S = 1
                EndIf 
            EndIf 
            $endif
            ' Other Timers?
            ' Your code...
        EndIf
        $endif
        '-----------------------------------------------------------------------
        $ifdef _SMVDelay_
        ' Delay 1mS for the States.
        If F_SMVDelay = 1 Then           ' The VDelay is started.
            Dec SMDelayCounter          ' Decrements the SMDelayCounter every 1mS.
            If SMDelayCounter = 0 Then  ' Check if delay counter reaches 0.
                F_SMVDelay = 0           ' Delay END, clear the Vdelay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay1_
        ' Count every 1mS.
        If F_Delay1 = 1 Then            ' The Delay is started.
            Dec Delay1Counter           ' Decrements the DelayCounter every 1mS.
            If Delay1Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay1 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay2_
        ' Count every 1mS.
        If F_Delay2 = 1 Then            ' The Delay is started.
            Dec Delay2Counter           ' Decrements the DelayCounter every 1mS.
            If Delay2Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay2 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
        $ifdef _Delay3_
        ' Count every 1mS.
        If F_Delay3 = 1 Then            ' The Delay is started.
            Dec Delay3Counter           ' Decrements the DelayCounter every 1mS.
            If Delay3Counter = 0 Then   ' Check if delay counter reaches 0.
                F_Delay3 = 0            ' Delay End, clear the delay FLAG.
            EndIf
        EndIf
        $endif  
        '-----------------------------------------------------------------------
    EndIf    
'-------------------------------------------------------------------------------
    ' PORTB.0 Interrupt (Signal 1Hz from the DS1307)
    If INTCONBits_INT0IF = 1 Then
        INTCONBits_INT0IF = 0
        F_DS1307_1S = 1
    EndIf
'-------------------------------------------------------------------------------
' Here the another user interrupt handler code....
' .......
' .......
' .......
'-------------------------------------------------------------------------------
END_INT:
'-------------------------------------------------------------------------------
    Context Restore          ' Exit the interrupt handler and restore variables
    Declare Reminders = On
'*******************************************************************************
'*******************************************************************************
'* Name    : EEPROM Data                                                       *
'* Purpose : Write some strings in the EEPROM memory                           *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : For testing the HRSE2PStrg(Address Eeprom) command                *
'*******************************************************************************
E2p_AddressString1 EData "Testing the STATE MACHINE STM05D scheduler",0

E2p_AddressString2 EData "using the Amicus18 Board (PIC18F25K20)",0

E2p_AddressString3 EData "by Alberto Freixanet.",0
'*******************************************************************************
STM_START:
'*******************************************************************************
' PLACE to insert the library files:
'*******************************************************************************
'* Name    : DS1307-H.Inc                                                      *
'* Purpose : DS1307 Clock Calendar library                                     *
'* Notes   :                                                                   *
'*******************************************************************************  
'   Hardware/Software I2C pins
    Declare SDA_Pin = PORTC.4   ' SDA connected to this pin
    Declare SCL_Pin = PORTC.3   ' SCL connected to this pin
    Declare Hbus_Bitrate 100    ' Bus frequency 100kHz to 1000 Khz that is better for SM.
'    Declare Slow_Bus = On  
'-------------------------------------------------------------------------------
' Library for the DS1307 Clock Calendar.  
    ' I2C Harware of the PIC (HBusOut/HBusIn) with ACK control.
    $define _EnableGIE_Save_
    Include "D:\MyIncFiles\DS1307-H.inc"    

    ' I2C Software of the PIC (BusOut/BusIn) with ACK control.
'    Include "D:\MyIncFiles\DS1307-S.inc"    
'*******************************************************************************
'* Name    : LCD_ST7036.Inc                                                    *
'* Purpose : LCD ST7036 driver                                                 *
'* Notes   :                                                                   *
'*******************************************************************************
    $ifndef _ProteusDebug_    
    Include "D:\MyIncFiles\LCD_ST7036.inc"
    $endif
'*******************************************************************************
'* Name    : HRsout_K40.Inc                                                    *
'* Purpose : HRSout1,2,3,4,5 command for 1 or 2 stop bits                      *
'* Notes   :                                                                   *
'*******************************************************************************
    $define _DisableAllinterrupt_
    Include "D:\MyIncFiles\HRsout_K40.inc"
'*******************************************************************************
'* Name    : ORG_SyncBlock_K20.Inc                                             *
'* Purpose : Generate an ORG command syncronized with Erase Blocks, K20 series *
'* Notes   : For Cdata Tables                                                  *
'******************************************************************************* 
    Include "D:\MyIncFiles\ORG_SyncBlock_K20.inc"
' Syntax: ORG_EBlock(pAddress)  
'===============================================================================
    $ifdef _DebugStates_
        $ifdef _DisableCRBeforeState_
        $undef _DisableCRBeforeState_
        $endif
    $endif    
'###MAIN CODE###################################################################
STMAIN:
'*******************************************************************************
'* Name    : Init some variables                                               *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
    F_SWDTEN = 0            ' Sure, disable the Watchdog
    INTCON = 0              ' Disable all interrupts
    TBLPTRU = 0

' Init the PORTS
'    ANSEL = 0
'    ANSELH = 0
'    CM1CON0 = 0
'    CM2CON0 = 0
    PORTA = 0               ' Clear all ports
    LATA = 0
    PORTB = 0
    LATB = 0    
    PORTC = 0
    LATC = 0
    Output LED1
    ' Clear the LCD_BackLight.
    Output LCD_Backlight
    Low LCD_Backlight
'===============================================================================
    DelayMS 250             ' Delay for LCD to stabilize.
    Cls    
'-------------------------------------------------------------------------------
' Init the PORTS
    Output LED1
    Output LED2
    Input Button1
    Input Button2
    Input Button3
    Input Button4
    $ifdef _PinsTest_
    Output Test1
    Output Test2
    $endif
'*******************************************************************************
'* Name    :                                                                   *
'* Purpose : Initialize some variables of the State Machine                    *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************
    SM_UserFunctionFlags = 0
'    SM_UserFlags = 0
    SM_AllFlags = 0         ' Clear all flags to begin.
'-------------------------------------------------------------------------------
     InitStateMachine()
'###############################################################################
'#### STATE MACHINE STARTS #####################################################
' The Main code Start Here:
StateMachineInit:
'*******************************************************************************
'* Name    : NextState(0)                                                      *
'* Purpose : Initialize the State Machine.                                     *
'* Notes   : Start the first state.                                            *
'*******************************************************************************
    NextState(0)
'*******************************************************************************
'* Name    : StateMachineStart                                                  *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   : The ReturnSM() goes Here:                                         *
'*******************************************************************************
StateMachineStart:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : USER Functions                                                    *
'* Purpose : Write some Timing functions                                       *
'* Notes   : Using Timing flags only                                           *
'*******************************************************************************
' RUN Timer function: 
    $ifdef _Synchronize1mS_
    If F_Timer1mS = 1 Then
        F_Timer1mS = 0
        ' Your Code...
    EndIf
    $endif
'-------------------------------------------------------------------------------
    $ifdef _Synchronize10mS_
    If F_Timer10mS = 1 Then
        F_Timer10mS = 0
        ' Your Code...
    EndIf
    $endif
'-------------------------------------------------------------------------------
' RUN User Function1: Toggle the LED5 every 1/2 second.
    If F_UserFunction1 = 1 Then
        LED1 = F_Timer500mS
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function2: Clear LED2 after a delay2.
    If F_UserFunction2 = 1 Then
        If F_Delay2 = 0 Then
            LED2 = 0
            F_UserFunction2 = 0
        EndIf
    EndIf
'-------------------------------------------------------------------------------
' RUN User Function3: 

'-------------------------------------------------------------------------------

'*******************************************************************************
'* Name    : States Machine Scheduler                                                          
'* Purpose : Running the code of all modules.                   
'* Notes   : Do not forget update the State Label.                                            
'===============================================================================
'  Running the States Machine2 in BackGround.
$ifdef _StatesMachine2_
    If State2Index > 0 Then
        GoTo StateMachine2Start 
    EndIf
$endif
' Return from States Machine2
ReturnStateMachine2:
'===============================================================================
    ' Running the Module Delay. The F_SMVDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SMVDelay_
    If F_SMVDelay = 1 Then
        GoTo StateMachineStart  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
    '===========================================================================
    ' Update the LABELS when you add a new States Machine Module.
    BranchL StateIndex,[STATE00,STATE01,STATE02,STATE03,STATE04,STATE05,STATE06,_
    STATE07,STATE08,STATE09,STATE10,STATE11,STATE12,STATE13,STATE14,STATE15,STATE16]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex is OUT of RANGE.
    $ifdef _SMVDelay_
    F_SMVDelay = 0
    $endif
    $ifdef _EnableTerminal_
    _HRSOut "STATE OUT OF RANGE: ", Dec StateIndex,CR,LF
    DelayMS 1000
    $endif
    ' ERROR in States Machine Variable Range. Reset the States Machine. 
    GoTo StateMachineInit  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################
'*******************************************************************************
'* Name    : STATE00                                                          
'* Purpose : Initialize the project in the terminal window                     
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : Start the first state.                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE00:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-############################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    HRSLStrg(TXT0,AllChars,0) : HRSOut " STM05",CR,LF    ' "STATES MACHINE"
    HRSLStrg(TXT1,1)        ' "By A. Freixanet"
    '---------------------------------------------------------------------------
    Cls
    PrintStrg(TXT0,1,1)     ' "STATES MACHINE"
    PrintStrg(TXT1,2,1)     ' "By A. Freixanet"
    '---------------------------------------------------------------------------
    NextStateDelay(1500,IncState)  ' Goto State 01 with 1500 mS delay. 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE01 [SM_ProjectInfo]   
'* Purpose : Initialize the project in the terminal window                     
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : Start the first state.                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE01:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-############################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    $ifdef _ST7036_INC_
    HRSLStrg(TXT33,1)           ' "Using the ST7036 LCD with the LCD Driver <LCD_ST7036.inc>"
    Cls
    PrintStrg(TXT33,1,1,16)     ' "Using the ST7036"
    PrintStrg(TXT34,2,1)        ' "<LCD_ST7036.Inc>"
    $endif

    HRSLStrg(TXT2,1)    ' "Test1_DS1307.bas file"
    HRSLStrg(TXT3,1)    ' "Testing the DS1307 Clock Calendar"
    HRSLStrg(TXT28,1)   ' "Using the library <DS1307-H.Inc>"
    HRSLStrg(TXT4,1)    ' "Sending Date & Time every minute to the terminal."    
    HRSLStrg(TXT5,0)    ' "The Hserial Baud Rate is set to "  

    $if _HSerialBaud_ = 9600
    HRSLStrg(TXT6,0)    ' "9600"
    $endif
    $if _HSerialBaud_ = 19200
    HRSLStrg(TXT7,0)    ' "19200"
    $endif
    $if _HSerialBaud_ = 38400
    HRSLStrg(TXT8,0)    ' "38400"
    $endif
    $if _HSerialBaud_ = 57600
    HRSLStrg(TXT9,0)    ' "57600"
    $endif
    $if _HSerialBaud_ = 115200
    HRSLStrg(TXT10,0)    ' "115200"
    $endif
    HRSLStrg(TXT23,1)    ' " Bauds."

    $ifdef _ProteusDebug_
    HRSLStrg(TXT31,1)           ' "Clock = 16 Mhz for Proteus testing"
    $else
    HRSLStrg(TXT32,1)           ' "Clock = 64 Mhz For real piece testing"    
    $endif
    '---------------------------------------------------------------------------
    ' Sending more information from the eeprom to the terminal.
    HRSOut CR,LF
    ' Send 1st String.
    HRSE2PStrg(E2p_AddressString1,1)
    ' Send 2nd String.
    HRSE2PStrg(E2p_AddressString2,1)
    ' Send 3rd String.
    HRSE2PStrg(E2p_AddressString3,1)
    '---------------------------------------------------------------------------
    $ifdef _ST7036_INC_
    ' Waiting 2000mS before to go to the next State. (2 examples)
    NextStateDelay(2000,IncState) 
    $else
    NextStateDelay(1000,IncState)
    $endif

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE02  (SM_CheckACK)                                                        
'* Purpose : Check if the DS1307 is present on the I2C bus.                               
'* Input   : None                                                             
'* Output  : None                                                            
'* Notes   : The ReturnACK must to be = 0.                                                                 
'===============================================================================
' Define the Global variables used in this state:
    Dim ReturnACK As Byte
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE02:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-############################################################
    HRSLStrg(TXT11,1)               ' "Check the DS1307 ackknowledge."
    HRSLStrg(TXT12,1)               ' Check if the DS1307 Clock Calendar is connected?
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)   ' Module synchronized with timing 1mS.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ' Only check value = 0, other values could be = 1 to 255.
    DS1307_Present(ReturnACK)
    If ReturnACK = 1 Then
        HRSLStrg(TXT14,1)           ' "NACK DS1307 RTC device!", CR
        NextState(SM_Error_NACK)    ' The program demo cannot run.
    Else
        HRSLStrg(TXT13,1)           ' "The DS1307 Device is ready!", CR
        StartFunction1()            ' Start Blinking the LED1
        NextState(SM_Enable1Hz)
    EndIf  

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE03  (SM_Enable1Hz)                                                          
'* Purpose : Config the DS1307 to output the 1Hz signal.                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                    
'===============================================================================
' Define the Global variables used in this state:
    Dim AllButtons As Byte
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE03:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-############################################################
    HRSLStrg(TXT15,1)   ' "Enable signal Output with frequency = 1 Hz."
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)   ' Module synchronized with timing 1mS.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ' Write to the Config register: Enable signal output with frequency = 1 Hz.
    DS1307_WriteControl(%10010000, ReturnACK)
    If ReturnACK = 1 Then
        HRSLStrg(TXT16,1)                   ' "NACK DS1307 Write Control", CR
        NextStateDelay(1000,SM_Error_NACK)  ' Waiting 1000mS before to go to SM_Error_NACK State.
    Else
        NextState(SM_AskForConfig)          ' Menu Configuration if necessary.
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)  ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    HRSOut CR,LF
'    AllButtons = 0  
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE04  (SM_Config)                                              *
'* Purpose : Configure a valor to the DS1307.                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Write all data in the DS1307 calendar                             *
'===============================================================================
' Define the Global variables used in this state:
    Dim MyDS1307_Array[8] As Byte
    Dim VSecond    As MyDS1307_Array#0     ' Second (0..59)
    Dim VMinute    As MyDS1307_Array#1     ' Minute (0..59)
    Dim VHour      As MyDS1307_Array#2     ' Hour    (0..11 or 0..23)
    Dim VDayOfWeek As MyDS1307_Array#3     ' Day of the week (1..7)
    Dim VDay       As MyDS1307_Array#4     ' Date  (0..31)
    Dim VMonth     As MyDS1307_Array#5     ' Month (1..12)
    Dim VYear      As MyDS1307_Array#6     ' Year  (0..99)
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE04:
'===============================================================================
    StateInit() 
    '##-INIT SECTION-############################################################
    HRSLStrg(TXT61,1)   ' "Update the Time & Date"
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)   ' Module synchronized with timing 1mS.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

' Code for configuring the DS1307. Only write it once to PIC. 
' If the RTC have a Battery only, compile again without this lines
'  & write to the PIC again.
    ' Config Time and Date to the clock calendar.

    DS1307_WriteDate(VDayOfWeek, VDay, VMonth, VYear, ReturnACK)    ' Write a new date
    If ReturnACK = 1 Then
        HRSLStrg(TXT29,1)                           ' "NACK DS1307 Write Date"
    EndIf
    '---------------------------------------------------------------------------
    Sync1mS()   ' DS1307_WriteTime command synchronized with timing 1mS.
    '---------------------------------------------------------------------------
    DS1307_WriteTime(VHour, VMinute, 0, ReturnACK) ' Write a new time   
    If ReturnACK = 1 Then
        HRSLStrg(TXT30,1)                           ' "NACK DS1307 Write Time"
    EndIf
    '---------------------------------------------------------------------------
    If ReturnACK = 1 Then
        NextState(SM_Error_NACK)        ' The program demo cannot run. 
    Else
        NextState(SM_ReadTimeDate)      ' Write with success.
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================    
    ReturnSM()
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE05 (SM_ReadTimeDate)                                                         
'* Purpose : READING Time & Date                                          
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : MAIN program: Read the Time every second & Read the date every minute.
'*           Set the Backlight to 5 Sec every minute to see the Time & Date on the LCD.
'*           INFINITE LOOP                                                                 
'===============================================================================
' Define the Global variables used:
    Dim ButtonsVirtualPORT As Byte
    Dim SW1 As ButtonsVirtualPORT.0
    Dim SW2 As ButtonsVirtualPORT.1    
    Dim SW3 As ButtonsVirtualPORT.2    
    Dim SW4 As ButtonsVirtualPORT.3

    Dim BacklightTime As Byte
    Dim MinuteCounter As Byte
    Dim RTC_Minute_Old As Byte
    Dim STM2Value As Byte
    Dim STM2Value2 As Byte
    Dim SetFunctionOneMinute As Bit
    Dim RTC_DayName As String * 9         ' Holds the name of the day
    Dim RTC_MonthName As String * 10      ' Holds the name of the month
' Define the Local variables used in this state:

' Define the Symbols used :
    Symbol BacklightTimeValue = 5   ' Backlight Set for 5 sec
'===============================================================================
STATE05:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    High LCD_Backlight                  ' Set the Backlight to see the value on the LCD.
    BacklightTime = BacklightTimeValue  ' Backlight Set Time
    ' Initialise some values.
    MinuteCounter = 0
    RTC_Minute_Old = 0
    INTCONBits_INT0IF = 0
    INTCONBits_INT0IE = 1   ' Enable INT0 interrupt for PORTB.0.
    INTCON2bits_INTEDG0 = 0
    IOCB = 0
    STM2Value = "@"
    STM2Value2 = "0"     
    SetFunctionOneMinute = 0
    Cls
    '##-END INIT-###############################################################
    StateInitEnd(SyncOn)   ' Module synchronized with timing 1mS.
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If F_DS1307_1S = 1 Then             ' Timing 1 Sec from DS1307 interrupt.
        F_DS1307_1S = 0
        '-----------------------------------------------------------------------
        NextState2(SM2_Function1)       ' Start a code (every second) in BackGround with the States Machine2.
                                        ' This code is executed always after this module.
        '-----------------------------------------------------------------------
        DS1307_ReadTime(ReturnACK)      ' Read the time from the DS1307
        If ReturnACK = 1 Then
            HRSLStrg(TXT18,1)           ' "NACK DS1307 Read Time"        
            NextState(SM_Error_NACK)
            GoTo ERROR05EXIT            ' Bypass the code below.
        EndIf
        '=======================================================================
        If RTC_Minute <> RTC_Minute_Old Then
            '-----------------------------------------------------------------------
            High LCD_Backlight                  ' Set the Backlight to see the value on the LCD.
            BacklightTime = BacklightTimeValue  ' Backlight Set Time
            '-----------------------------------------------------------------------
            ' Minutes Counter send the counter to the terminal.
            Inc MinuteCounter
            If MinuteCounter = 60 Then
                MinuteCounter = 0
            EndIf
            HRSLStrg(TXT24,0)               ' "Minutes Count: "
            HRSOut Dec2 MinuteCounter,CR,LF
            '-------------------------------------------------------------------
            Sync1mS()   ' (DS1307_ReadDate) Command synchronized with interrupt 1mS.
            '-------------------------------------------------------------------
            ' Write the Date to test only
            DS1307_ReadDate(ReturnACK)      ' Read the date from the DS1307

            If ReturnACK = 1 Then
                HRSLStrg(TXT19,1)           ' "NACK DS1307 Read Date"
                NextState(SM_Error_NACK)
                GoTo ERROR05EXIT            ' Bypass the code below.
            EndIf

            ' Get the day's name into string RTC_DayName
            DS1307_Get_DayName(RTC_DayOfWeek, RTC_DayName) 
            ' Get the months's name into string RTC_MonthName
            DS1307_Get_MonthName(RTC_Month, RTC_MonthName) 
        
            HRSLStrg(TXT20,0)   ' "Date = "
            HRSOut RTC_DayName, " ",_        ' \
                   Dec2 RTC_Day, "/",_       ' | Serially transmit 
                   Dec2 RTC_Month,_          ' | the date as ASCII
                   "/20", Dec RTC_Year,CR,LF ' /
        
            HRSLStrg(TXT21,0)   ' "Time = "            
            HRSOut Dec2 RTC_Hour, ":",_      ' \
                   Dec2 RTC_Minute, ":",_    ' | Serially transmit 
                   Dec2 RTC_Second,CR,LF     ' / the time as ASCII
            HRSOut CR,LF
            RTC_Minute_Old =  RTC_Minute     ' Save the new minute value.
            '-----------------------------------------------------------------------
            SetFunctionOneMinute = 1    ' Start a code (every minute) in BackGround with the States Machine2.
                                        ' This code is executed always after this module.
            '-----------------------------------------------------------------------                                    
        EndIf                        
        '=======================================================================
        ' Print the Date to the LCD every second.
            Print At 1,1, Str RTC_DayName\5, " ",_  '\
                            Dec2 RTC_Day, "/",_     '| Print the Date to the LCD.
                            Dec2 RTC_Month,_        '|
                            "/20", Dec RTC_Year     '/
        ' Print the Time to the LCD every second.
            Print At 2,1, Dec2 RTC_Hour, ":",_      '\ Print the Time To the LCD.
                          Dec2 RTC_Minute, ":",_    '|
                          Dec2 RTC_Second, " ",_    '|
                          Str RTC_MonthName\5       '/ Print the Month Name To the LCD. Str RTC_MonthName\7 
            'Print At 2,10, Str RTC_MonthName\7 
            '-------------------------------------------------------------------
            ' PRINT the Results to the LCD generated by the States Machine2 in BackGround.
            ' in Position 15 and 16 of the LCD.
            ' Print initial values at firt time.
            Print At 2,15, STM2Value2, STM2Value
        '-----------------------------------------------------------------------
        ' Delay to stop the Backlight after 4 Sec.
        If BacklightTime > 0 Then                
            Dec BacklightTime     ' Decrement the Backlight counter every second.
            If BacklightTime = 0 Then
                Low LCD_Backlight
            EndIf
        EndIf    
    EndIf    
    '---------------------------------------------------------------------------
    ' Press the Button2 if configuration of Time/Date is needed again.
    If F_DS1307_1S = 0 Then             ' Out off Timing 1 Sec from DS1307 interrupt.
        GoSub ReadButtons2PORT_Sub      ' Read all Buttons.
        If SW2 = 0 Then                 ' If SW2 pressed...
            AllButtons = 0
            NextIndState(SM_ButtonsOFF2,SM_AskForConfig)    ' Indirect address
        EndIf
    EndIf    
    '---------------------------------------------------------------------------
ERROR05EXIT:    ' This LABEL must be inside the MAIN Module.
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0) ' Delay between execution of MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    If ReturnACK = 1 Then
        Low LCD_Backlight
    EndIf
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE06 (SM_Error_NACK)                                                          
'* Purpose : Send a String To the terminal read from the data eeprom memory.   
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   :                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
    Dim ReadingPORTA As SMLVSByte1
' Define the Symbols used :

'===============================================================================
STATE06:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    NextState2(SM2_Init)    ' Stop the States Machine2.
    HRSLStrg(TXT22,1)       ' "Warning: Communication error! ACK no valid."
    HRSLStrg(TXT25,1)       ' "Press the Button 1 to ReStart the programm."
    Cls 
    PrintStrg(TXT26,1,1)    ' "NACK DS1307"
    PrintStrg(TXT27,2,1)    ' "RESTART? => S1"
    StopFunction1()         ' Stop Blinking the LED1.
    '##-END INIT-###############################################################
    StateInitEnd()    
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtons2PORT_Sub              ' Read all Buttons.
    If SW2 = 0 Then                         ' If SW2 pressed...
        NextIndState(SM_ButtonsOFF2,SM_CheckACK)    ' Indirect addressing
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)     ' Read the Button every 30 mS.
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd() 
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE07 [SM_AskForConfig]                                                      
'* Purpose :                                                
'* Input   : None                                                          
'* Output  : None                                                            
'* Notes   :                                                         
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE07:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    Cls
    PrintStrg(TXT41,1,1)    ' "Config DS1307?"
    PrintStrg(TXT42,2,1)    ' "S2=YES  OTHER=NO"
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Select AllButtons
        Case 2                      ' Response YES => Go to Get Week.
            AllButtons = 3
            VDayOfWeek = 0
            StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out 10 seconds 
            NextState(SM_GetWeek)

        Case 1,3,4                  ' Response NO => Read Time & Date
            AllButtons = 0                     
            NextState(SM_ReadTimeDate)

        Case Else
        ' Make a loop with the SM_ButtonsOFF Module.
        StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out 10 seconds 
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    EndSelect

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)             ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE08 [SM_ButtonsOFF]                                                       
'* Purpose : Check all Buttons are OFF                      
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : Waiting the Buttons until OFF.       
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
 
' Define the Symbols used:

'===============================================================================
STATE08:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################

    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtonsPORT_Sub   ' Init & Read all Buttons.

    ' Waiting All Buttons OFF (All Buttons have a Pull-up resistor).
    If ButtonsVirtualPORT = 255 Then
        NextStateDelay(30,SM_ReadButtons)   ' Delay 30mS to exit the state.
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE09 [SM_ReadButtons]
'* Purpose : Read All Buttons in PORTA
'* Input   : None
'* Output  : None                                                             
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:
    Dim KEYnOld As Byte
    Dim KEYCounter As Byte
' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE09:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
'    HRSLStrg(TXT40,1)       ' "Waiting a Button pressed!"
    KEYnOld = 0             ' Initialize parameters for debouncing.
    KEYCounter = 0
    AllButtons = 0
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtons2PORT_Sub                  ' Read all Buttons.

    If ButtonsVirtualPORT < 255 Then            ' If one Button pressed.
        If KEYnOld = ButtonsVirtualPORT Then    ' Some debounce system
            Inc KEYCounter
            If KEYCounter = 4 Then              ' 4 + 1 readings necessary.
                KEYCounter = 0
                '---------------------------------------------------------------
                If SW1 = 0 Then                 ' Check Button 1.
                    AllButtons = 1
                    IncState()
                EndIf
                If SW2 = 0 Then                 ' Check Button 2.
                    AllButtons = 2
                    IncState()
                EndIf            
                If SW3 = 0 Then                 ' Check Button 3.
                    AllButtons = 3
                    IncState()
                EndIf
                If SW4 = 0 Then                 ' Check Button 4.
                    AllButtons = 4
                    IncState()
                EndIf            
                '---------------------------------------------------------------
            EndIf
        Else
            KEYCounter = 0
        EndIf
        KEYnOld = ButtonsVirtualPORT
    Else
        KEYCounter = 0
    EndIf
    '---------------------------------------------------------------------------
    ' Check the Time Out & goto the correspondent state.
    CheckTimeOut()

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)    ' Adjust some sample time 30mS to debounce the Buttons.
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ 
    StateOutEnd()
'===============================================================================
    ReturnSM()
'===============================================================================
'* Name    : ReadButtonsPORT_Sub                                              
'* Called From: SM_ButtonsOff, SM_ReadButtons                                     
'* Purpose : Read all Buttons                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : 4 Buttons in PORTA                          
'===============================================================================  
' Define the Global variables used in this state:

' Define the Symbols used :

'===============================================================================
ReadButtonsPORT_Sub:
    ANSEL = 0                       ' PORTA digital
    TRISA = TRISA | %00001111       ' SW0 to SW3 for input.
    DelayUS 100
ReadButtons2PORT_Sub:
    ButtonsVirtualPORT = PORTA      ' Read SW0 to SW3
    ButtonsVirtualPORT = ButtonsVirtualPORT | %11110000
    Return
'===============================================================================
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE10 [SM_ButtonsOFF2]                                                       
'* Purpose : Waiting the Buttons Until OFF.                     
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : Using the Indirect addressing [ReturnIndState()]     
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:
 
' Define the Symbols used:

'===============================================================================
STATE10:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    StartBeep()     ' Start a pulse of the Buzzer or LED2.
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    GoSub ReadButtons2PORT_Sub   ' Read all Buttons.

    ' Waiting All Buttons OFF (All Buttons have a Pull-up resistor).
    If ButtonsVirtualPORT = 255 Then
        ReturnIndState()    ' Load the Return State defined by the caller.
    EndIf

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(30)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE11 [SM_GetWeek]                                                      
'* Purpose : Module to configurate the Day of Week.                                                
'* Input   : None                                                          
'* Output  : None                                                            
'* Notes   : (DayOfWeek, Day, Month, Year)                                                       
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE11:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    Cls
    PrintStrg(TXT43,1,1)    ' "Day of Week? S3+"
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 3 Then
        AllButtons = 0
        Inc VDayOfWeek
        If VDayOfWeek > 7 Then
            VDayOfWeek = 1
        EndIf
        Select VDayOfWeek        
        CLL(2)
        Case 1
            PrintStrg(TXT44,2,1)            ' "Sunday" 
        Case 2
            PrintStrg(TXT45,2,1)            ' "Monday"
        Case 3
            PrintStrg(TXT46,2,1)            ' "Tuesday"
        Case 4
            PrintStrg(TXT47,2,1)            ' "Wednesday"
        Case 5
            PrintStrg(TXT48,2,1)            ' "Thursday"
        Case 6
            PrintStrg(TXT49,2,1)            ' "Friday"
        Case 7
            PrintStrg(TXT50,2,1)            ' "Saturday"
        EndSelect
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3                     
        VDay = 14
        NextState(SM_GetDay)

    ElseIf AllButtons = 4 Then
        AllButtons = 0
        NextState(SM_ReadTimeDate)          ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out 10 seconds 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE12 [SM_GetDay]                                                        
'* Purpose : Module To configurate the Day (1 to 31).                                                 
'* Input   : None                                                              
'* Output  : None                                                             
'* Notes   : (DayOfWeek, Day, Month, Year)                                                                 
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE12:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    Cls
    PrintStrg(TXT51,1,1)    ' "S1-   Day?   S3+"
    PrintStrg(TXT56,2,1)    ' "Day: "
    '##-END INIT-###############################################################
    StateInitEnd() 
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 3 Then          ' Button (+)
        AllButtons = 0
        Inc VDay
        If VDay > 31 Then
            VDay = 1
        EndIf
        Print Dec2 VDay
        NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3                     
        VMonth = 5
        NextState(SM_GetMonth)

    ElseIf AllButtons = 1 Then      ' Button (-)
        AllButtons = 0
        Dec VDay
        If VDay = 0 Then
            VDay = 31
        EndIf
        Print Dec2 VDay
        NextIndState(SM_ButtonsOFF,CallerState) ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        AllButtons = 0
        NextState(SM_ReadTimeDate)  ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.  
    EndIf

    StartTimeOut(SM_ReadTimeDate,10) ' Start a Time Out 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE13 [SM_GetMonth]                                                      
'* Purpose : Module To configurate the Month (1 to 12).                                               
'* Input   : None                                                             
'* Output  : None                                                             
'* Notes   : (DayOfWeek, Day, Month, Year)                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
    Symbol MaxYear = 35 
    Symbol ThisYear = 17
'===============================================================================
STATE13:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    Cls
    PrintStrg(TXT52,1,1)    ' "S1-  Month?  S3+"
    PrintStrg(TXT57,2,1)    ' "Month: "
    '##-END INIT-###############################################################
    StateInitEnd() 
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 3 Then              ' Button (+)
        AllButtons = 0
        Inc VMonth
        If VMonth > 12 Then
            VMonth = 01
        EndIf
        Print Dec2 VMonth
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3                     
        VYear = ThisYear - 1
        NextState(SM_GetYear)

    ElseIf AllButtons = 1 Then        ' Button (-)
        AllButtons = 0
        Dec VMonth
        If VMonth = 0 Then
            VMonth = 12
        EndIf
        Print Dec2 VMonth
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 4 Then        ' Escape.
        AllButtons = 0
        NextState(SM_ReadTimeDate)

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE14  [SM_GetYear]                                                       
'* Purpose : Module To configurate the Year.                                                
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : (DayOfWeek, Day, Month, Year)                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE14:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    Cls
    PrintStrg(TXT53,1,1)    ' "S1-  Year?   S3+"
    PrintStrg(TXT58,2,1)    ' "Year: "
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 3 Then          ' Button (+)
        AllButtons = 0
        Inc VYear
        If VYear > MaxYear Then
            VYear = ThisYear
        EndIf
        Print Dec2 VYear
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3                     
        VHour = 11
        NextState(SM_GetHour)

    ElseIf AllButtons = 1 Then      ' Button (-)
        AllButtons = 0
        Dec VYear
        If VYear < ThisYear Then
            VYear = ThisYear
        EndIf
        Print Dec2 VYear
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        AllButtons = 0
        NextState(SM_ReadTimeDate) ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here. 
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    
    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE15 [SM_GetHour]                                                       
'* Purpose : Module To configurate the Hour.                                                
'* Input   : None                                                             
'* Output  : None                                                              
'* Notes   : DS1307_WriteTime(VHour, VMinute, VSecond)                                                                   
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE15:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    Cls
    PrintStrg(TXT54,1,1)    ' "S1-  Hour?   S3+"
    PrintStrg(TXT59,2,1)    ' "Hour: "
    '##-END INIT-###############################################################
    StateInitEnd()    
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 3 Then              ' Button (+)
        AllButtons = 0
        Inc VHour
        If VHour > 23 Then
            VHour = 0
        EndIf
        Print Dec2 VHour
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 3                     
        VMinute = 29
        NextState(SM_GetMinute)

    ElseIf AllButtons = 1 Then          ' Button (-)
        AllButtons = 0
        Dec VHour
        If VHour = 255 Then
            VHour = 23
        EndIf
        Print Dec2 VHour
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        AllButtons = 0          
        NextState(SM_ReadTimeDate)      ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE16 [SM_GetMinute]                                                       
'* Purpose : Module To configurate the Minutes.                                                 
'* Input   : None                                                              
'* Output  : None                                                              
'* Notes   : DS1307_WriteTime(VHour, VMinute, VSecond)                                                                    
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE16:
'===============================================================================
    StateInit()
    '##-INIT SECTION-############################################################
    Cls
    PrintStrg(TXT55,1,1)    ' "S1- Minute?  S3+"
    PrintStrg(TXT60,2,1)    ' "Minute: "
    '##-END INIT-###############################################################
    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    If AllButtons = 3 Then          ' Button (+)
        AllButtons = 0
        Inc VMinute
        If VMinute > 59 Then
            VMinute = 0
        EndIf
        Print Dec2 VMinute
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 2 Then
        AllButtons = 0                     
        NextState(SM_Config)       ' END of configuration of the DS1307 calendar.

    ElseIf AllButtons = 1 Then     ' Button (-)
        AllButtons = 0
        Dec VMinute
        If VMinute = 255 Then
            VMinute = 59
        EndIf
        Print Dec2 VMinute
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.

    ElseIf AllButtons = 4 Then
        AllButtons = 0          
        NextState(SM_ReadTimeDate) ' Escape.

    Else
        ' Make a loop with the SM_ButtonsOFF Module.
        NextIndState(SM_ButtonsOFF,CallerState)    ' Load the present state to return here.
    EndIf

    StartTimeOut(SM_ReadTimeDate,10)      ' Start a Time Out for 10 seconds

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    StartDelayMS(0)
'===============================================================================
    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOutEnd()    
'===============================================================================
    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE17 []                                                           
'* Purpose :                                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                  
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE17:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-############################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE18  []                                                       
'* Purpose :                                                  
'* Input   : None                                                               
'* Output  : None                                                               
'* Notes   :                                                                    
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE18:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-############################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE19  []                                                      
'* Purpose :                                                     
'* Input   : None                                                            
'* Output  : None                                                            
'* Notes   :                                                               
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE19:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-############################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::MAIN CODE:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===EXIT SECTION=================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************

'*******************************************************************************
'* Name    : STATE20                                                           *
'* Purpose :                                                                   *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:
'===============================================================================
STATE20:
'===============================================================================
'    StateInit()
    '##-INIT SECTION-############################################################

    '##-END INIT-###############################################################
'    StateInitEnd()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

          
':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'    StartDelayMS(0)    ' Delay between execution of the MAIN module (adjust the delay)
'===============================================================================
'    StateOut()
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
'    StateOutEnd()    
'===============================================================================
'    ReturnSM() 
'*******************************************************************************
'###############################################################################
'#### STATE MACHINE2 STARTS ####################################################
$ifdef _StatesMachine2_
' The Main code Start Here:
'*******************************************************************************
'* Name    : StateMachine2Start                                                *
'* Purpose : Clear the Watchdog If enabled.                                    *
'* Notes   :                                                                   *
'*******************************************************************************
StateMachine2Start:
    #ifdef WatchDog_Req
    Clrwdt
    #endif 
'*******************************************************************************
'* Name    : States Machine2 Scheduler                                                          
'* Purpose : Running the code of all modules.                   
'* Notes   : Do not forget update the State Label.                                            
'===============================================================================
    ' Running the Module2 Virtual Delay. The F_SM2VDelay flag must be clear by a Timer running
    ' in the interrupt handler.
    $ifdef _SM2VDelay_
    If F_SM2VDelay = 1 Then
        GoTo ReturnStateMachine2  '  Waiting delay for the States Machine1.            
    EndIf
    $endif
'===============================================================================
    ' Update the LABELS when you add a new States Machine Module.
    BranchL State2Index,[STATE100,STATE101,STATE102]
    '---------------------------------------------------------------------------
    ' Debug section. StateIndex2 is OUT of RANGE.
    $ifdef _SM2VDelay_
    F_SM2VDelay = 0     ' Clear any VDelay2
    $endif
    $ifdef _EnableTerminal_
    _HRSOut "STATE MACHINE2 OUT OF RANGE: ", Dec State2Index,13,10
    DelayMS 1000
    $endif
    NextState2(0)
    ' ERROR in States Machine2 Variable Range. Reset the States Machine2. 
    GoTo ReturnStateMachine2  ' Equivalent of Reset On stack overflow. 
'#### STATE MACHINE END ########################################################
'###############################################################################
'*******************************************************************************
'* Name    : STATE100 [SM2_Init]       
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : A not used Label is needed For the Scheduler.                                                            
'===============================================================================
STATE100:
    ' Nothing to do.
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE101 [SM2_Function1]        
'* Purpose : Print a message to the LCD in Background                                                      
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : Increment a Value every second & goto Stop                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE101:
'===============================================================================
    StateInit2()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInit2End()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Inc STM2Value
    If STM2Value > "Z" Then
        STM2Value = "A"
    EndIf
    ' After the code is executed the Module is stop and goes to State = 0,
    ' waiting a new start.

    If SetFunctionOneMinute = 1 Then
        SetFunctionOneMinute = 0
        NextState2(SM2_Function2)   ' Start a code (every minute) in BackGround with the States Machine2.
    Else
        NextState2(SM2_Init) 
    EndIf  

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    SM2StartDelayMS(0)
'===============================================================================
    StateOut2(0)        ' Disable the Time Counter (NO code).
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************
'*******************************************************************************
'* Name    : STATE102 [SM2_Function2]        
'* Purpose :                                                       
'* Input   : None                                                      
'* Output  : None                                                        
'* Notes   : Increment a Value & GoTo Stop                                                            
'===============================================================================
' Define the Global variables used in this state:

' Define the Local variables used in this state:

' Define the Symbols used:

'===============================================================================
STATE102:
'===============================================================================
    StateInit2()
    '##-INIT SECTION-###########################################################

    '##-END INIT-###############################################################
    StateInit2End()
':::-MAIN CODE-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    Inc STM2Value2
    If STM2Value2 > "9" Then
        STM2Value2 = "0"
    EndIf
    ' After the code is executed the Module is stop and goes to State = 0,
    ' waiting a new start. 
    NextState2(SM2_Init) 

':::-EXIT MAIN-:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    SM2StartDelayMS(0)
'===============================================================================
    StateOut2(0)        ' Disable the Time Counter (NO code).
    '$$$-EXIT SECTION-$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$

    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
    StateOut2End()    
'===============================================================================
    ' Return to States Machine 1.
    ReturnSM1() 
'*******************************************************************************


'*******************************************************************************
'*******************************************************************************
' End of States Machine2
$endif  
'*******************************************************************************
'###############################################################################
'###############################################################################
'*** SUBROUTINES ***************************************************************
'*******************************************************************************
' Subroutines of the project.
''*******************************************************************************
''* Name    : ReadEEPString_Sub                                                 *
''* Purpose : Read a String written in the eeprom memory.                       *
''* Input   : None                                                              *
''* Output  : None                                                              *
''* Notes   : Use Bytes System only for variables                               *
''*******************************************************************************
' Define the Global variables used in this state:

' Define the Symbols used:

'===============================================================================


'*******************************************************************************
'* Name    :                                                *
'* Purpose : Read the state all buttons of the Board                           *
'*         : To the terminal.                                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'******************************************************************************* 
' Define the Global variables used in this state:

' Define the Symbols used:

'===============================================================================

'    Return
'*******************************************************************************
'* Name    :                                         *
'* Purpose :                        *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   :                                                                   *
'*******************************************************************************  
' Define the Global variables used in this state:

' Define the Symbols used:



'===============================================================================

'===============================================================================


'*******************************************************************************
'* Name    : STM_Strings04.Inc                                                 *
'* Purpose : CData Table for Strings or Datas                                  *
'* Input   : None                                                              *
'* Output  : None                                                              *
'* Notes   : Write the Tables at top of memory syncronized with Erase Block    *
'*         : The Cdata table could have 1600 Bytyes                            *
'*         : Table of Strings of the program                                   *
'*******************************************************************************
'    ORG_EBlock(_MAXMEM - 800)
    Include "D:\MyIncFiles\STM_Strings05.Inc"
'*******************************************************************************
' Write some static data to the ID Locations.
' STM5DV10
Asm
__IDLOCS   __IDLOC0,0x53
__IDLOCS   __IDLOC1,0x54
__IDLOCS   __IDLOC2,0x4D
__IDLOCS   __IDLOC3,0x35
__IDLOCS   __IDLOC4,0x44
__IDLOCS   __IDLOC5,0x56
__IDLOCS   __IDLOC6,0x31
__IDLOCS   __IDLOC7,0x30
EndAsm
'*******************************************************************************
'*** END OF FILE ***************************************************************
'*******************************************************************************

                
